#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>  /*  MAXPATHLEN  */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "define.h"
#include "lf.h"

/* ////////////////////////////////////////////////////////////////////////////
////            MyColor                                                    ////
////            顼Υԥͤ                                 ////
//////////////////////////////////////////////////////////////////////////// */
unsigned long MyColor(pDisplay, color)
    Display *pDisplay;
    char    *color;
{
    XColor   c0, c1;
    Colormap cmap;

    cmap = DefaultColormap(pDisplay, 0);
    XAllocNamedColor(pDisplay, cmap, color, &c0, &c1);
    return(c1.pixel);
}


/* ////////////////////////////////////////////////////////////////////////////
////            color_define                                               ////
//////////////////////////////////////////////////////////////////////////// */
void color_define()
{
    Colormap cm;
    int i;
    static int flags = DoRed | DoGreen | DoBlue;

    cm = DefaultColormap(pDisplay, 0);
    if ( color_flag ) {
      if ( !XAllocColorCells(pDisplay, cm, False, pl, 4, px, 2)) {
	/*	fprintf(stderr, "XAllocColorCells failed\n");*/
	color_flag = 0;
      }
    }

    if ( color_flag ) {
	XStoreNamedColor(pDisplay, cm, bgcolor, px[0], flags); /*  طʿ  */
	XStoreNamedColor(pDisplay, cm, fgcolor, px[1], flags); /*  ʿ  */

	for ( i = 0 ; i < 2 ; i ++ ) {
	    XStoreNamedColor(pDisplay, cm, bgcolor, px[i] | pl[0]                  , flags); /*  ʿʤ  */
	    XStoreNamedColor(pDisplay, cm, cgcolor, px[i] | pl[0]|pl[1]            , flags); /*    */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] | pl[0]|pl[1]|pl[2]      , flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] | pl[0]|pl[1]|pl[2]|pl[3], flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] | pl[0]|      pl[2]      , flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] | pl[0]|      pl[2]|pl[3], flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, egcolor, px[i] | pl[0]|            pl[3], flags); /*  顼  */
	    XStoreNamedColor(pDisplay, cm, cgcolor, px[i] |       pl[1]            , flags); /*    */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] |       pl[1]|pl[2]      , flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] |       pl[1]|pl[2]|pl[3], flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] |       pl[1]|      pl[3], flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, tgcolor, px[i] |             pl[2]      , flags); /*  ʸ  */
	    XStoreNamedColor(pDisplay, cm, dgcolor, px[i] |             pl[2]|pl[3], flags); /*    */
	    XStoreNamedColor(pDisplay, cm, egcolor, px[i] |                   pl[3], flags); /*  顼  */
	}
	nfgcolor = px[1];
	nbgcolor = pl[0];
	ncgcolor = pl[1];
	ntgcolor = pl[2];
	negcolor = pl[3];
	ndgcolor = pl[2]|pl[3];
    } else {
	px[1] = nfgcolor = MyColor(pDisplay, fgcolor);
	px[0] = nbgcolor = MyColor(pDisplay, bgcolor);
	ncgcolor = MyColor(pDisplay, cgcolor);
	ntgcolor = MyColor(pDisplay, tgcolor);
	negcolor = MyColor(pDisplay, egcolor);
	ndgcolor = MyColor(pDisplay, dgcolor);
    }

    nhgcolor = MyColor(pDisplay, hgcolor);
    nmgcolor1 = MyColor(pDisplay, mgcolor1);
    nmgcolor2 = MyColor(pDisplay, mgcolor2);
    nmgcolor3 = MyColor(pDisplay, mgcolor3);
    nmgcolor4 = MyColor(pDisplay, mgcolor4);
    nrgcolor = MyColor(pDisplay, "Red");
}
