#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include "define.h"
#define NOT_X
#include "lf.h"
#undef NOT_X

extern char *search_notspace();

/*
   debug   
   Ucmd_area
*/
#ifdef DEBUG
void Ucmd_area_debug()
{
  char *ptr = Ucmd_area;
  struct  lf_stat  *current_lf;

/*  for ( ; ptr < Ucmd_unuse ; ptr++ ) {*/
  for ( ; ptr < Ucmd_area+72 ; ptr++ ) {
    if ( *ptr ) 
      printf("%c", *ptr);
    else
      printf(".");
  }  
  printf("\n");

  ptr = Ucmd_area;
  for ( ; ptr < Ucmd_area+72 ; ptr++ ) {
    if ( ptr == Ucmd_unuse )
      printf("|");
    else
      printf(" ");
  }
  printf("\n");

  current_lf = first_lf;
  while ( current_lf ) {
    if ( current_lf->Ucmd )
      printf("Ucmd : %x -> %s\n", current_lf->Ucmd, current_lf->Ucmd);
    current_lf = current_lf->next;
  }
  printf("Ucmd_area : %x  -- %x\n\n", Ucmd_area, Ucmd_unuse);
}
#endif

/* ////////////////////////////////////////////////////////////////////////////
////            ucase    ѾʸʸѴ                            ////
////            lcase    ʸʸѴ                            ////
//////////////////////////////////////////////////////////////////////////// */
void ucase(ptr, nlen)
    char    *ptr;
    int     nlen;
{
    int     i;

    for ( i=0 ; i<nlen ; i++, ptr++ ) {
        if ( *ptr >= 'a' && *ptr <= 'z' ) {
            *ptr = *ptr - ('a' - 'A');
        }
    }
}

void lcase(ptr, nlen)
    char    *ptr;
    int     nlen;
{
    int     i;

    for ( i=0 ; i<nlen ; i++, ptr++ ) {
        if ( *ptr >= 'A' && *ptr <= 'Z' ) {
            *ptr = *ptr + ('a' - 'A');
        }
    }
}


/* ////////////////////////////////////////////////////////////////////////////
////            function_execute                                           ////
//////////////////////////////////////////////////////////////////////////// */
void function_execute(index)
    int     index;
{
    if ( ctrl_flag )
        Execute(spt[selfile], ckcmd[index]);
    else if ( alt_flag )
        Execute(spt[selfile], akcmd[index]);
    else if ( shift_flag )
        Execute(spt[selfile], skcmd[index]);
    else
        Execute(spt[selfile], fkcmd[index]);
}


/* ////////////////////////////////////////////////////////////////////////////
////         Execute                                                       ////
////         ޥɤ¹Ԥ                                            ////
//////////////////////////////////////////////////////////////////////////// */
int Execute(fileNo, command)
    int     fileNo;
    char    command[];
{
#define LCASE 1
#define UCASE 2
    FILE    * fp;
    char    *fname, paf[256];
    char    *jaixterm = windowenv1;
    char    *jaixterm17 = windowenv2;
    char    *ptr = command, exefile[50];
    char    *fname_last;
    char    tar_command[256];
    int     namelen, i, j, ret, nlen, jw, pause, fcase, fname_use;
    struct  lf_stat  *current_lf;

    if ( ptr ) {
      while ( *ptr ) {
        if ( *ptr != ' ' )
          break;
        ptr++;
      }
    } else
      return 0;

    if ((ptr == strstr(ptr, "@Sort_name"))) {
        shell_sort(SORT_NAME);
        sortflag_name = ~sortflag_name;
        return 0;
    } else if ((ptr == strstr(ptr, "@Sort_mode"))) {
        shell_sort(SORT_MODE);
        sortflag_mode = ~sortflag_mode;
        return 0;
    } else if ((ptr == strstr(ptr, "@Sort_size"))) {
        shell_sort(SORT_SIZE);
        sortflag_size = ~sortflag_size;
        return 0;
    } else if ((ptr == strstr(ptr, "@Sort_owner"))) {
        shell_sort(SORT_OWNER);
        sortflag_owner = ~sortflag_owner;
        return 0;
    } else if ((ptr == strstr(ptr, "@Sort_date"))) {
        shell_sort(SORT_DATE);
        sortflag_date = ~sortflag_date;
        return 0;
    } else if ((ptr == strstr(ptr, "@Sort_dott"))) {
        shell_sort(SORT_DOTT);
        sortflag_dott = ~sortflag_dott;
        return 0;
    } else if ((ptr == strstr(ptr, "@Sort_link"))) {
        shell_sort(SORT_LINK);
        sortflag_link = ~sortflag_link;
        return 0;
    } else if ((ptr == strstr(ptr, "@Environment"))) {
        Environment_list();
        return 0;
    } else if ((ptr == strstr(ptr, "@Refresh"))) {
        Refresh();
        return 0;
    }

    Msg_Run(True);
    pause = j = 0;

    if ( *ptr == '!' ) {
        ptr++;
        if ( *ptr == '!' ) {
            ptr++;
            strcpy(asm_command, jaixterm17);
            strcat(asm_command, " -e ");
            if ( *ptr == '?' ) {
                ptr++;
                pause = 1;
            }
        } else {
            strcpy(asm_command, jaixterm);
            strcat(asm_command, " -e ");
            if ( *ptr == '?' ) {
                ptr++;
                pause = 1;
            }
        }
        j = strlen(asm_command);
    }
    i = ptr - command;

    current_lf = (struct lf_stat *)pfile[fileNo];
    fname = current_lf->st_name;
    strcpy(paf, fname);
    namelen = strlen(paf);

    if ( (ptr = strchr(paf, '.')))
        nlen = ptr - paf;
    else
        nlen = namelen;

    if ( tgz_flag )
      if ( fname_last = strrchr(fname, '/'))  /*  fname_last    */
	fname_last++;
      else
	fname_last = fname;

    jw = j;
    fname_use = fcase = 0;

    for (     ; i < strlen(command) ; i++) {
        asm_command[j] = command[i];
        if ( asm_command[j] == '(' ) {
            if ( strstr(command+i, "(lcase)") == command+i ) {
                fcase = LCASE;
                i += 6;
                continue;
            } else if ( strstr(command+i, "(l)") == command+i ) {
                fcase = LCASE;
                i += 2;
                continue;
            } else if ( strstr(command+i, "(ucase)") == command+i ) {
                fcase = UCASE;
                i += 6;
                continue;
            } else if ( strstr(command+i, "(u)") == command+i ) {
                fcase = UCASE;
                i += 2;
                continue;
            }
        }

        if ( asm_command[j] == '\\' ) {
          if ( command[i+1] == '\\' ) {   /* 96/12/26 ɲ */
            i++;                         /* '\' Ѥ */
            j++;
          } else {
            strcpy(asm_command + j, paf );
            if ( command[i+1] == 'n' ) {  /*  ǽ . ޤǤΥե̾  */
                if (fcase == UCASE )
                    ucase(asm_command+j, nlen);
                else if (fcase == LCASE )
                    lcase(asm_command+j, nlen);
                i++;
                j += nlen;
            } else if ( command[i+1] == 'p' ) {  /*  Path  */
                strcpy(asm_command + j, opath);
                if (fcase == UCASE )
                    ucase(asm_command+j, strlen(opath));
                else if (fcase == LCASE )
                    lcase(asm_command+j, strlen(opath));
                i++;
                j += strlen(opath);
            } else if ( command[i+1] == 'z' && tgz_flag ) {  /*  fname_last  */
                strcpy(asm_command + j, fname_last);
                if (fcase == UCASE )
                    ucase(asm_command+j, strlen(fname_last));
                else if (fcase == LCASE )
                    lcase(asm_command+j, strlen(fname_last));
                i++;
                j += strlen(fname_last);
            } else {  /*  ե̾  */
	        fname_use = 1;
                if (fcase == UCASE )
                    ucase(asm_command+j, namelen);
                else if (fcase == LCASE )
                    lcase(asm_command+j, namelen);
                j += namelen;
            }
            fcase = 0;
          }
        } else
            j++;
    }
    asm_command[j] = 0;

    if ( !return_flag ) {
        if ( pause == 1 ) {
/*          strcpy(exefile, "/tmp/lf.execute"); */
            sprintf(exefile, "/tmp/lf.%d", rand());

            if ( !(fp = fopen(exefile, "w"))) {
                fprintf(stderr, "*** Could not open %s\n", exefile);
                exit (4);
            }

            fprintf(fp, "#!/bin/sh\n%s\n", asm_command + jw);
            fprintf(fp, "echo \n");
            fprintf(fp, "echo Push enter key\n");
            fprintf(fp, "read key\n");
            fprintf(fp, "rm %s\n", exefile);
            fclose (fp);
            strcpy(asm_command + jw, exefile);
            strcat(asm_command, " &");
            chmod(exefile, 0755);
        }
	
	/*  xxx.tgz ե /tmp˿ĥ  */
	if ( tgz_flag == 1 && fname_use ) {
	  if ( !strstr(asm_command, "tar xvfzO" )) {
	    sprintf(tar_command, "tar xvfz %s %s", opath, fname);
	    if ((ret = system(tar_command))) {
	      /*  顼äƤ ret 0 ǤäƤˤʤ  */
	      beep();
	      goto jmp;
	    }
	  }
	}
	
	/*  xxx.lzh ե /tmp˿ĥ  */
	if ( tgz_flag == 2 && fname_use ) {
	  if ( !strstr(asm_command, "lha p " )) {
	    sprintf(tar_command, "lha x %s %s", opath, fname);
	    if ((ret = system(tar_command))) {
	      beep();
	      goto jmp;
	    }
	  }
	}
	
	
	/*  xxx.zip ե /tmp˿ĥ  */
	if ( tgz_flag == 3 && fname_use ) {
	  if ( !strstr(asm_command, "unzip -p " )) {
	    sprintf(tar_command, "unzip -x %s %s", opath, fname);
	    if ((ret = system(tar_command))) {
	      beep();
	      goto jmp;
	    }
	  }
	}
	
	/*  ޥɤ¹Ԥ  */
        printf("%s\n", asm_command + jw);
        if ((ret = system(asm_command)))
            beep();

	/*  /tmp˿ĥե  */
/*          ˤäƤϼ¹˺ΤǼߤ 
	if ( tgz_flag )
	  if ( unlink(fname))
	    fprintf(stderr, "unlink Error %s\n", fname);
*/
    } else
        ret = 1;
  jmp:
    Msg_Run(False);
    return ret;
}



/* ////////////////////////////////////////////////////////////////////////////
////           Ucmd_move                                                   ////
////           Ucmd_area ΰư                                            ////
//////////////////////////////////////////////////////////////////////////// */
void Ucmd_move(s1, s2, n, inc)
     char *s1, *s2;
     int n, inc;
{
  char *ptr;
  struct  lf_stat  *current_lf;
  
  memmove(s1, s2, n);
  Ucmd_unuse += inc;
  
  current_lf = first_lf;
  while ( current_lf ) { 
    if ( s2 < current_lf->Ucmd ) {
      current_lf->Ucmd += inc;
    }
    current_lf = current_lf->next;
  }
}


/* ////////////////////////////////////////////////////////////////////////////
////           UExecute                                                    ////
////           Ucommand ¹Ԥ                                         ////
//////////////////////////////////////////////////////////////////////////// */
void UExecute()
{
    static char    oldcom[256];
    char    *ptr;
    int     i, ret, al, ul;
    struct  lf_stat  *current_lf;

    for ( i = 0 ; i < nfile ; i++) {
        current_lf = (struct lf_stat *)pfile[spt[i]];
        if ( current_lf->ersflag == '1' )
            continue;

        if ( current_lf->Ucmd ) {
          if ( !(ptr = search_notspace(current_lf->Ucmd)))
            continue;
        } else
            continue;
        if ( *ptr == '*' )
            continue;
        else {
            if ( *ptr == '=' ) {
                ret = Execute(spt[i], oldcom);
            } else {
                ret = Execute(spt[i], ptr);
                strcpy(oldcom, ptr);
            }

            if ( return_flag ) {
	      ul = strlen(current_lf->Ucmd);
	      al = strlen(asm_command);
	      ptr = current_lf->Ucmd + ul;
	      Ucmd_move(current_lf->Ucmd + al, ptr, Ucmd_unuse - ptr,
			al - ul);
	      strcpy(current_lf->Ucmd, asm_command);
            }

            if ( ret == 0 ) {
                if ( *current_lf->Ucmd != ' ' )
                  Ucmd_move(current_lf->Ucmd + 1, current_lf->Ucmd,
			   Ucmd_unuse - current_lf->Ucmd, 1);
                *current_lf->Ucmd = '*';
            }

#ifdef DEBUG
	    Ucmd_area_debug();
#endif
	  }
    }
    lf_draw();
}


/* ////////////////////////////////////////////////////////////////////////////
////           MExecute                                                    ////
////           Mcommand ¹Ԥ                                         ////
//////////////////////////////////////////////////////////////////////////// */
void MExecute()
{
    char    *Mcha,  iMcha, *fname;
    int     i, j, m, ispt, ret;
    struct  lf_stat  *current_lf;

    for ( i = 0 ; i < nfile ; i++) {
        ispt = spt[i];
        current_lf = (struct lf_stat *)pfile[spt[i]];
        if ( current_lf->ersflag == '1' )
            continue;

        iMcha = current_lf->Mcmd;
        if ( iMcha == '*' || iMcha == ' ' )
            continue;

        /* ----------  file erase  ---------- */
        if ( iMcha == 'e' ) {
            fname = current_lf->st_name;
            printf("unlink : %s\n", fname);
            if ( !unlink(fname)) {
                current_lf->Mcmd = ' '; /* '*'; */
                current_lf->ersflag = '1';
            } else {
                fprintf(stderr, "unlink Error %s\n", fname);
                beep();
            }
            continue;
        }

        Mcha = *Mcmd;
        m = 0;
        while ( Mcha ) {
            if ( iMcha == *Mcha ) {
                if ( !(ret = Execute(ispt, *(Mcmd + m) + 2)))
                    current_lf->Mcmd = '*';
                break;
            }
            Mcha = *(Mcmd + (++m));
        }
        if ( !Mcha )
            beep();
    }
    lf_draw();
}
