#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>  /*  MAXPATHLEN  */
#include <locale.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "define.h"
#include "lf.h"


/* ////////////////////////////////////////////////////////////////////////////
////            SetNewFont                                                 ////
////            եȾ򥻥å                                       ////
//////////////////////////////////////////////////////////////////////////// */
void SetNewFont()
{
    int     missing_count;
    char    **missing_clist;
    char    *def_str;
    XRectangle ink_rect, logical_rect;

    if ( !jflag ) {
        if ( !(pFontInfo = XLoadQueryFont (pDisplay, sFontName))) {
            fprintf(stderr, "Can't load font : %s\n", sFontName);
            exit(4);
        }
        XSetFont(pDisplay, gc, pFontInfo->fid);
        ascent = pFontInfo->max_bounds.ascent;
        descent = pFontInfo->max_bounds.descent;
        nFontHeight = ascent + descent;
        nFontWidth = XTextWidth(pFontInfo, "str", 1);
    } else {                        /* --------   ܸ졡  -------- */
        if ( fontflag )
	  strcpy(jsFontName, sFontName);

        setlocale(LC_CTYPE, locale);
        if ( !(fontset = XCreateFontSet(pDisplay, jsFontName, &missing_clist,
                                        &missing_count, &def_str))) {
            fprintf(stderr, "Can't load font : %s\n", jsFontName);
            exit (4);
        }
        XmbTextExtents(fontset, "str", 3, &ink_rect, &logical_rect);
        ascent = -logical_rect.y;
        descent = logical_rect.height + logical_rect.y;

        fontset_ext = XExtentsOfFontSet(fontset);
        nFontHeight = fontset_ext->max_logical_extent.height;
        nFontWidth  = fontset_ext->max_logical_extent.width / 2;
    }
}
