
#ifndef NOT_X
extern XFontStruct     *pFontInfo;
extern Display         *pDisplay;
extern GC              gc;
extern XEvent          report;
extern Window          window;
extern KeySym          myKeysym;
extern XComposeStatus  myStatus;
extern XFontSet        fontset;
extern XFontSetExtents *fontset_ext;
#endif

extern struct lf_stat {
    char    *st_name;           /* File Name                      */
    short   st_nlink;           /* Number of links                */
    mode_t  st_mode;            /* File mode; see #define's below */
    uid_t   st_uid;             /* User ID of the file's owner    */
    gid_t   st_gid;             /* Group ID of the file's group   */
    off_t   st_size;            /* File size in bytes             */
    time_t  st_mtime1;          /* Time of last access            */
    char    Mcmd;               /* Mcommand ϰ */
    char    *Ucmd;              /* Ucommand ϰ */
    char    ersflag;            /* File Erase Flag */
    struct  lf_stat  *next;
}  *first_lf;

extern char    **pfile;                /* lf_stat *next pointer */
extern int     nfile;                  /* File ο */
extern int     *spt;                   /* struct lf_stat  index */
extern char    my_Hname[64];           /* Host Name */
extern char    my_Uid[10];             /* Owner Id  */
extern char    my_Gid[10];             /* Group Id  */
extern char    my_PWD[MAXPATHLEN];        /* PWD       */
extern char    ipath[MAXPATH];         /* in  Path  */
extern char    opath[MAXPATH];         /* out Path  */
extern char    outbuf[256];
extern char    sFontName[MAXBUFF];     /* Font Name */
extern char    jsFontName[MAXBUFF];    /* ܸ Font Name */
extern char    windowenv1[MAXBUFF];    /* New Window  ! */
extern char    windowenv2[MAXBUFF];    /* New Window  !! */
extern char    buffer[MAXBUFF];
extern char    asm_command[256];       /* Ÿ줿 Ucommand */
extern char    locale[20];             /* LC_CTYPE */

extern unsigned int    uWidth;         /* Window Size */
extern unsigned int    uHeight;        /* Window Size */

extern unsigned long   nbgcolor ;   /* Back Ground Color */
extern unsigned long   nfgcolor ;   /* Fore Ground Color */
extern unsigned long   ncgcolor ;   /* Select file Color */
extern unsigned long   ntgcolor ;   /* Text        Color */
extern unsigned long   negcolor ;   /* Execute Err Color */
extern unsigned long   ndgcolor ;   /* File Erase  Color */
extern unsigned long   nhgcolor ;   /* Host ...    Color */
extern unsigned long   nmgcolor1;   /* Function msg1 Color */
extern unsigned long   nmgcolor2;   /* Function msg2 Color */
extern unsigned long   nmgcolor3;   /* Function msg3 Color */
extern unsigned long   nmgcolor4;   /* Function msg4 Color */
extern unsigned long   nrgcolor;    /* Running msg Color */

extern unsigned long   px[2];       /* base pixel */
extern unsigned long   pl[4];       /* plane mask */

extern char    bgcolor[MAXCOLOR];    /* Back Ground Color */
extern char    fgcolor[MAXCOLOR];    /* Fore Ground Color */
extern char    cgcolor[MAXCOLOR];    /* Select file Color */
extern char    tgcolor[MAXCOLOR];    /* Text        Color */
extern char    egcolor[MAXCOLOR];    /* Execute Err Color */
extern char    dgcolor[MAXCOLOR];    /* File Erase  Color */
extern char    hgcolor[MAXCOLOR];    /* Host ...    Color */
extern char    mgcolor1[MAXCOLOR];   /* Function msg1 Color */
extern char    mgcolor2[MAXCOLOR];   /* Function msg2 Color */
extern char    mgcolor3[MAXCOLOR];   /* Function msg3 Color */
extern char    mgcolor4[MAXCOLOR];   /* Function msg4 Color */

extern int     dis_top;         /* Display Top File No.      */
extern int     dis_bottom;      /* Display Bottom File No.   */
extern int     dis_msg;         /* Display Message Position  */
extern int     dis_lines;       /* Display File Max          */
extern int     dis_cursor;      /* Display Select File Posision   */

extern int     sortflag_name;        /* Sort Flag */
extern int     sortflag_mode;        /* Sort Flag */
extern int     sortflag_size;        /* Sort Flag */
extern int     sortflag_owner;       /* Sort Flag */
extern int     sortflag_date;        /* Sort Flag */
extern int     sortflag_dott;        /* Sort Flag */
extern int     sortflag_link;        /* Sort Flag */
extern int     fontflag;             /* -fn  */
extern int     jflag;                /* ܸ ڤ괹 */
extern int     cmode;                /* command ڤ괹 */
extern int     shift_flag;           /* Shift_key flag */
extern int     ctrl_flag;            /* Ctrl_key flag */
extern int     alt_flag;             /* Alt_key flag */
extern int     insert_flag;          /* Insert key flag */
extern int     home_flag;            /* Home   key flag */
extern int     return_flag;          /* Return Key flag */
extern int     expose_flag;          /* Expose ˥֤Ѥʤ */
extern int     date_flag;            /* File Date flag */
extern int     execute_flag;         /* Execute flag */
extern char    in_date[14];              /* yymmdd-yymmdd */
extern int     refresh_flag;         /* refresh flag */
extern int     seiki_flag;           /* seikika flag */
extern int     tgz_flag;             /* tgz flag   1:tgz   2:lzh */
extern int     color_flag;           /* 0:ɸ   1:ץ饤١ */
extern int     action_flag;          /* 0:Enter key  1:Action key */
extern int     stdin_flag;           /* 0:           1:stdin */

extern int     Ucurrent_pkey; /* Ucmd current pkey */
extern int     curxx;         /* Cursor Position */
extern int     curyy;         /* Cursor Position */
extern int     selfile;       /* Select File No */
extern int     pkey;
extern int     nFontHeight;   /* ʸ⤵ */
extern int     nFontWidth;    /* ʸ   */
extern short int       ascent, descent;  /* Font ascent, descent */
extern unsigned long   size_total;       /* File Size  */
extern fname_over;      /*  ե̾ 25ʸۤʬʸ  */

extern char *tgz_uid[100];
extern char *tgz_gid[100];
extern int ntgz_uid, ntgz_gid;
extern int lzh_type; 
extern char lzh_permission_type[10];  /* [xxxxxxx] */
extern char *Ucmd_area;
extern char *Ucmd_unuse;              /* Ucmd_area ̤ΰΥݥ󥿡 */

extern char    *fkcmd[13];         /* Function Key Command */
extern char    *fkmsg[];
extern char    *fkcmd_default[];
extern char    *skcmd[13];         /* Shift Key Command */
extern char    *skmsg[];
extern char    *ckcmd[13];         /* Ctrl Key Command */
extern char    *ckmsg[];
extern char    *akcmd[13];         /* Alt Key Command */
extern char    *akmsg[];
extern char    *pMcmd;
extern char    *Mcmd_default[];
char    *Mcmd[MAXMCOMM];

/*  end  */
