#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>  /*  MAXPATHLEN  */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include "define.h"
#include "lf.h"

/* ////////////////////////////////////////////////////////////////////////////
////            QLines                                                     ////
////            ɥ˲뤫                               ////
//////////////////////////////////////////////////////////////////////////// */
int QLines()
{
    int     nLines;

    nLines = uHeight / nFontHeight;
    return nLines;
}


/* ////////////////////////////////////////////////////////////////////////////
////            search_notspace                                            ////
////            ʸ椫ʳʸõ                           ////
//////////////////////////////////////////////////////////////////////////// */
char *search_notspace(ptr)
    char    *ptr;
{
    while ( *ptr ) {
        if ( *ptr != ' ' )
            return ptr;
        ptr++;
    }
    return NULL;
}


/* ////////////////////////////////////////////////////////////////////////////
////            Change_Cursor                                              ////
////            ޥѹ                                       ////
//////////////////////////////////////////////////////////////////////////// */
void Change_Cursor(cursor_type)
    int     cursor_type;
{
    Cursor  MyCursor;

    MyCursor = XCreateFontCursor(pDisplay, cursor_type);
    XDefineCursor(pDisplay, window, MyCursor);
}


/* ////////////////////////////////////////////////////////////////////////////
////            Msg_Run                                                    ////
////            "Running" ɽ                                           ////
//////////////////////////////////////////////////////////////////////////// */
void Msg_Run(mode)
     int mode;
{
    static int offset = 1;
    static char *lf_type[] = { "       ", " (tgz) ", " (lzh) ", " (zip) " };

    XSetBackground(pDisplay, gc, px[0]);
    XSetForeground(pDisplay, gc, nrgcolor);
    if ( mode == True ) {
      Change_Cursor(XC_watch);
      DrawImageText(73, dis_msg, "Running", ALL, offset);
    } else {
      Change_Cursor(XC_gumby);
      DrawImageText(73, dis_msg, lf_type[tgz_flag], ALL, offset);
    }
    XFlush(pDisplay);
}


/* ////////////////////////////////////////////////////////////////////////////
////            lf_free                                                    ////
////            եå, Ѥ꡼             ////
//////////////////////////////////////////////////////////////////////////// */
void lf_free()
{
    int     i;
    struct  lf_stat  *current_lf;

    for ( i = 0 ; i < nfile ; i++ ) {
        current_lf = (struct lf_stat *)pfile[i];
        free (current_lf->st_name);
/*  1997.9.19
        if ( current_lf->Ucmd )
            free(current_lf->Ucmd);
*/
        free(pfile[i]);
    }
    free(pfile);
    free(spt);
    free(Ucmd_area);
    first_lf = NULL;

    nfile = 0;
    dis_top = 0;
    dis_cursor = 0;
    sortflag_name = 0;
    sortflag_mode = -1;
    sortflag_size = 0;
    sortflag_owner = 0;
    sortflag_date = -1;
    sortflag_dott = 0;
    sortflag_link = 0;
    fname_over = 0;
    cmode = M_COMMAND;
    shift_flag = 0;
    ctrl_flag = 0;
    alt_flag = 0;
    insert_flag = 0;
    home_flag = -1;
    curxx = 0;
    curyy = 2;
    selfile = 0;
    pkey = 0;
    Ucurrent_pkey = 0;
    execute_flag = 0;
    stdin_flag = 0;

    if ( chdir(my_PWD) ) {
        fprintf(stderr, "cannot chenge directory : %s\n", my_PWD);
        exit (1);
    }
}


/* ////////////////////////////////////////////////////////////////////////////
////            Refresh                                                    ////
////            եξ򿷤ɤ߹                             ////
//////////////////////////////////////////////////////////////////////////// */
void Refresh()
{
    int i;

    refresh_flag = 1;
    Msg_Run(True);
    lf_free();
    if ( tgz_flag ) 
      lf_set_tgz();
    else
      lf_set();

    uWidth = nFontWidth * (KETA+fname_over) + 2;
    i = GYO;
    if ( i > nfile + 3 )
        i = nfile + 3;
    uHeight = nFontHeight * i + 2;
    XResizeWindow(pDisplay, window, uWidth, uHeight);
    lf_draw();
    Msg_Run(False);
}


/* ////////////////////////////////////////////////////////////////////////////
////            Quit                                                       ////
////            λ                                                       ////
//////////////////////////////////////////////////////////////////////////// */
void Quit()
{
    if ( !jflag )
        XFreeFont(pDisplay, pFontInfo);
    else
        XFreeFontSet(pDisplay, fontset);

    XCloseDisplay(pDisplay);
    exit (0);
}


/* ////////////////////////////////////////////////////////////////////////////
////            beept                                                    ////
//////////////////////////////////////////////////////////////////////////// */
void beep()
{
  printf("\x07");
  fflush(stdout);
}
