/* ////////////////////////////////////////////////////////////////////////////
////            ե롦֥饦      Version 2.3                        ////
////                                                                       ////
////                   for X Window System                                 ////
////                                                   92/ 6/20    ////
////                                                       97/ 9/ 3    ////
//////////////////////////////////////////////////////////////////////////// */
/*
        Compile ˡ
          aix     : cc -o xbr xbr.c -qmbcs -lX11 -lm -DAIX
          FreeBSD : gcc -o xbr -O2 xbr.c -lX11 -lm -lxpg4 -DFreeBSD
*/
#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <ctype.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/cursorfont.h>
#include <X11/bitmaps/target>
#include <X11/keysym.h>
#include "xbr.xbm"

#define VERSION         "Version 2.3 97/ 9/3"
#define CRFLAG          -1       /* 0:off -1:on */
#define direct          dirent
#define MAXLINE         132
#define BGCOLOR         "moccasin"
#define FGCOLOR         "black"
#define SGCOLOR         "deeppink"
#define CGCOLOR         "brown"
#define HGCOLOR         "Blue"
#define AGCOLOR         "Skyblue"
#define NGCOLOR         "Deeppink"
#define LGCOLOR         "Red"
#define IGCOLOR1        "Green"
#define IGCOLOR2        "Yellow"
#define IGCOLOR3        "Pink"
#define IGCOLOR4        "Skyblue"
#define IGCOLOR5        "aquamarine"
#define IGCOLOR6        "peru"
#define IGCOLOR7        "tan"
#define IGCOLOR8        "deeppink"
#define IGCOLOR9        "purple"
#define IGCOLOR10       "magenta"
#define IGCOLOR11       "rosybrown"
#define IGCOLOR12       "gold"
#define BUFSIZE         1024
#define STDIN_SIZE      400000
#define ALL             0

Display        *pDisplay;
GC              gc;
XEvent          report;
Window          window, w1, w2;
Colormap        cmap;
KeySym          myKeysym;
XComposeStatus  myStatus;

int     flen;                   /* ե롦 */
int     x_offset = 0;           /* Υեå  */
int     tab = 8;                /* TAB */
int     nScreen;
int     line_keta;              /* Կ */
int     lWidth;                 /* Կ */
char    ipath[80];              /* in  Path    */
char    sFontName[MAXLINE];     /* Font Name   */

unsigned int    uWidth;                 /* Window Size */
unsigned int    uHeight;                /* Window Size */
unsigned int    ketamax = 0;            /* Data Max  */

unsigned long int       nbgcolor ;   /* Back Ground Color */
unsigned long int       nfgcolor ;   /* Fore Ground Color */
unsigned long int       nsgcolor ;   /* Select file Color */
unsigned long int       ncgcolor ;   /* Comment     Color */
unsigned long int       nhgcolor ;   /* Path        Color */
unsigned long int       nagcolor ;   /* 0x0a        Color */
unsigned long int       nngcolor ;   /* NULL        Color */
unsigned long           nigcolor[12] ;   /* Find    Color */
unsigned long           nlgcolor ;   /* Line NO     Color */

char    bgcolor[20];    /* Back Ground Color */
char    fgcolor[20];    /* Fore Ground Color */
char    sgcolor[20];    /* Select file Color */
char    cgcolor[20];    /* Comment     Color */
char    hgcolor[20];    /* Path        Color */
char    agcolor[20];    /* 0x0a        Color */
char    ngcolor[20];    /* NULL        Color */
char    label[80];      /* Title label */

int     dis_top = 0;       /* Display Top File No.      */
int     dis_bottom;        /* Display Bottom File No.   */
int     dis_msg;           /* Display Message Position  */
int     dis_lines;         /* Display File Max          */
int     dis_cursor = 0;    /* Display Select File Posision   */
int     shiftflag = 0;     /* Shift_key flag */
int     ctrlflag  = 0;     /* Control key flag */
int     expose_flag = 0;   /* expose flag */
int     crflag = CRFLAG;   /* ʸ */
int     lineflag = 0;      /* ֹ */
int     csrflag = 0;       /*  */
int     stdin_flag = 1;    /* ɸ */
int     stdin_size = STDIN_SIZE;  /* ɸ ꡼ */

int     xx_selline;        /* selline_draw() x position */
int     curxx = 0;         /* Cursor Position */
int     curyy = 1;         /* Cursor Position */
int     selline = 0;       /* Select File No */
int     nFontHeight;       /* ʸ⤵ */
int     nFontWidth;        /* ʸ   */
int     cfflag = 0;        /* 1:FORTRAN , 2:C */
int     fontflag = 0;      /* font flag */
int     jflag = 0;         /* ܸɽ */
int     sflag = 0;         /* select file type  */
short int       ascent, descent;  /* Font ascent, descent */
XFontSet        fontset;
XFontStruct     *pFontInfo = NULL;

int     nfind[12] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }; /* ʸ */
char    find[12][80];      /*  ʸ  */
int     findex;            /*  find index  */
char    outbuf[MAXLINE];

char    **plist;                /* List Pointer */
int     nplist = 0;             /* File ο */

struct comment_table {
    int start_row;              /*  ȻϤޤ  */
    int start_col;              /*  ȻϤޤ  */
    int end_row;                /*  Ƚԡ  */
    int end_col;                /*  Ƚ    */
    struct comment_table *next;
} *first_comment = NULL;
char **pctbl;
int     npctbl = 0;             /*  pctblΥ󥿡  */

struct null_table {
    int start_row;              /*  ̥ʸϤޤ  */
    int start_col;              /*  ̥ʸϤޤ  */
    int end_row;                /*  ̥ʸԡ  */
    int end_col;                /*  ̥ʸ    */
    struct null_table *next;
} *first_null = NULL;
char **pntbl;
int     npntbl = 0;             /*  pntblΥ󥿡  */

#ifdef AIX
#define JPFONT "-ibm_aix-gothic-medium-r-normal--19-120-100-100-m-*"
#define CTYPE  "Ja_JP"
#define FONT   "rom14"
#define TERM   "aixterm -fn ""*gothic*"" -rv"
#define EDITER "vi"
#endif

#ifdef FreeBSD
#define JPFONT  "kanji16,rk16"
#define CTYPE   "ja_JP.EUC"
#define FONT    "a14"
#define TERM    "kterm -rv"
#define EDITER  "elvis"
#endif

#ifdef Digital
#define JPFONT  "-JDECW-Screen-*-*-*--18-*-*-*-*-*-*-*"
#define CTYPE   "ja_JP"
#define FONT    "vt13"
#define TERM    "dxterm"
#define EDITER  "jvi"
#endif

char *C_reserve1[] = { "while", "switch", "case", "break", "default",
                       "if", "else", "for", "do", "return", "struct",
                       "exit", "continue", NULL };
char *C_reserve2[] = { "#define", NULL };
char *C_reserve3[] = { "#ifdef", "#ifndef", "#endif", "#else", "#include", NULL };

char *F_reserve1[] = { "PROGRAM", "SUBROUTINE", "FUNCTION", "INCLUDE",
                       "CALL", "RETURN", "STOP", "END", NULL };
char *F_reserve2[] = { "IF", "THEN", "ELSE", "ENDIF",
                       "GO", "TO", "DO", "WHILE", "CONTINUE", "FORMAT", NULL };
char *F_reserve3[] = { "COMMON", "CHARACTER", "REAL", "INTEGER", "DIMENSION",
                       "PARAMETER", "DATA", "SAVE", "IMPLICT", NULL };


/* ////////////////////////////////////////////////////////////////////////////
///            MyColor                                                     ////
//////////////////////////////////////////////////////////////////////////// */
unsigned long   MyColor(pDisplay, color)
Display *pDisplay;
char    *color;
{
    XColor c0, c1;
    cmap = DefaultColormap(pDisplay, 0);
    XAllocNamedColor(pDisplay, cmap, color, &c0, &c1);
    return(c1.pixel);
}


/* ////////////////////////////////////////////////////////////////////////////
////            color_define                                               ////
//////////////////////////////////////////////////////////////////////////// */
void color_define()
{
    nbgcolor = MyColor(pDisplay, bgcolor);
    nsgcolor = MyColor(pDisplay, sgcolor);
    nfgcolor = MyColor(pDisplay, fgcolor);
    ncgcolor = MyColor(pDisplay, cgcolor);
    nhgcolor = MyColor(pDisplay, hgcolor);
    nagcolor = MyColor(pDisplay, agcolor);
    nngcolor = MyColor(pDisplay, ngcolor);
    nlgcolor = MyColor(pDisplay, LGCOLOR);

    nigcolor[0] = MyColor(pDisplay, IGCOLOR1);
    nigcolor[1] = MyColor(pDisplay, IGCOLOR2);
    nigcolor[2] = MyColor(pDisplay, IGCOLOR3);
    nigcolor[3] = MyColor(pDisplay, IGCOLOR4);
    nigcolor[4] = MyColor(pDisplay, IGCOLOR5);
    nigcolor[5] = MyColor(pDisplay, IGCOLOR6);
    nigcolor[6] = MyColor(pDisplay, IGCOLOR7);
    nigcolor[7] = MyColor(pDisplay, IGCOLOR8);
    nigcolor[8] = MyColor(pDisplay, IGCOLOR9);
    nigcolor[9] = MyColor(pDisplay, IGCOLOR10);
    nigcolor[10] = MyColor(pDisplay, IGCOLOR11);
    nigcolor[11] = MyColor(pDisplay, IGCOLOR12);
}


/* ////////////////////////////////////////////////////////////////////////////
////           FontInfo        եȾ򥻥å                        ////
//////////////////////////////////////////////////////////////////////////// */
void FontInfoSet()
{
    int missing_count;
    char **missing_clist, *def_str;
    XFontSetExtents *fontset_ext;
    XRectangle ink_rect, logical_rect;

    if ( !jflag ) {
        if ( !(pFontInfo = XLoadQueryFont (pDisplay, sFontName))) {
            fprintf(stderr, "Can't load font : %s\n", sFontName);
            exit(4);
        }
        XSetFont(pDisplay, gc, pFontInfo->fid);
        ascent = pFontInfo->max_bounds.ascent;
        descent = pFontInfo->max_bounds.descent;
        nFontHeight = ascent + descent + 1;
        nFontWidth = XTextWidth(pFontInfo, "str", 1);
    } else {                    /* --------   ݲ  -------- */
        if ( !fontflag )
	    strcpy(sFontName, JPFONT);
        setlocale(LC_CTYPE,  CTYPE);
        if ( !(fontset = XCreateFontSet(pDisplay, sFontName, &missing_clist,
                                        &missing_count, &def_str))) {
            fprintf(stderr, "Can't load font : %s\n", sFontName);
            exit (4);
        }
	XmbTextExtents(fontset, "str", 3, &ink_rect, &logical_rect);
	ascent = -logical_rect.y;
	descent = logical_rect.height + logical_rect.y - 1;

        fontset_ext = XExtentsOfFontSet(fontset);
        nFontHeight = fontset_ext->max_logical_extent.height + 1;
        nFontWidth  = fontset_ext->max_logical_extent.width / 2;
    }
}


/* ////////////////////////////////////////////////////////////////////////////
///            DrawText()      ƥȤɽ                              ////
//////////////////////////////////////////////////////////////////////////// */
void    DrawText(int xx, int yy, char *str, int len)
{
    int xpos, ypos;

    xpos = nFontWidth * xx + 1;
    ypos = nFontHeight * (yy + 1) -  descent;
    if ( len == ALL )
        len = strlen(str);
    if ( !jflag )
        XDrawString(pDisplay, w1, gc, xpos, ypos, str, len);
    else
        XmbDrawString(pDisplay, w1, fontset, gc, xpos, ypos, str, len);
}


/* ////////////////////////////////////////////////////////////////////////////
///           DrawText2()      ƥȤɽ                              ////
//////////////////////////////////////////////////////////////////////////// */
void    DrawText2(int xx, int yy, char *str, int len)
{
    int xpos, ypos;

    xpos = nFontWidth * xx;
    ypos = nFontHeight * (yy + 1) -  descent;
    if ( len == ALL )
        len = strlen(str);
    if ( !jflag )
        XDrawString(pDisplay, w2, gc, xpos, ypos, str, len);
    else
        XmbDrawString(pDisplay, w2, fontset, gc, xpos, ypos, str, len);
}


/* ////////////////////////////////////////////////////////////////////////////
////           DrawImageText()      ᡼ƥȤɽ                 ////
//////////////////////////////////////////////////////////////////////////// */
void DrawImageText(int xx, int yy, char *str, int len)
{
    int xpos, ypos;

    xpos = nFontWidth * xx + 1;
    ypos = nFontHeight * (yy + 1) - descent;
    if ( len == ALL )
        len = strlen(str);
    if ( !jflag )
        XDrawImageString(pDisplay, w1, gc, xpos, ypos+1, str, len);
    else
        XmbDrawImageString(pDisplay, w1, fontset, gc, xpos, ypos, str, len);
}


/* ////////////////////////////////////////////////////////////////////////////
///            QLines()        ɥ˲뤫                ////
///               ͡                                                 ////
//////////////////////////////////////////////////////////////////////////// */
int QLines()
{
    int nLines;
    nLines = uHeight / nFontHeight;
    return nLines;
}


/* ////////////////////////////////////////////////////////////////////////////
///            Quit()                                                      ////
//////////////////////////////////////////////////////////////////////////// */
void Quit()
{
    if ( !jflag )
        XFreeFont(pDisplay, pFontInfo);
    else
        XFreeFontSet(pDisplay, fontset);

    XCloseDisplay(pDisplay);
    exit (0);
}


/* ////////////////////////////////////////////////////////////////////////////
///            tabspc                                                      ////
//////////////////////////////////////////////////////////////////////////// */
int     tabspc(char *string, char *string1, int tb)
{
    int  k = 0, m, rc;
    char *adrs = string1;
    while ( *string ) {
        k++;
        if ( k > tb )
            k = 1;

        if ( *string == '\t' ) {
            for ( m = 0 ; m <= tb - k ; m++ )
                *string1++ = ' ';
            k = 0;
            *string++;
        } else
            *string1++ = *string++;
    }
    *string1 = 0;
    rc = strlen(adrs);
    if ( BUFSIZE < rc )
        return(rc);
    return(0);
}


/* ////////////////////////////////////////////////////////////////////////////
////           Read_Data                                                   ////
//////////////////////////////////////////////////////////////////////////// */
char    *GetSource();
void Read_Data()
{
  int   nketa = 0, i, j, k, nulls = 0, tabflag = 0;
  int   flag = 0, col, fsize = 0;
  int c = 0;
  struct comment_table *new_comment, *current_comment;
  struct comment_table *old_comment;
  struct null_table *new_null, *current_null;
  struct null_table *old_null;

  char  *ptr, *ptr1, *buffer, *GetSource ();
  char  *startptr, *endptr;
  char  *oldptr, *tabptr;
  char  *orgoldptr, *orgptr;
  char  string[BUFSIZE];

  char *stdin_ptr[100];
  int nstdin_ptr = 0;
  int nstdin;

  flen = 0;
  if ( stdin_flag ) {		/*  ɸϤɤ߹  */
    while ( c != EOF ) {
      if ( nstdin_ptr > 99 ) {
	fprintf(stderr, "<<<  Out of Memory (stdin)  >>>\n");
	exit (4);
      }

      if ( !(stdin_ptr[nstdin_ptr] = calloc(1, stdin_size + 1))) {
	fprintf(stderr, "<<<  Out of Memory (stdin)  >>>\n");
	exit (4);
      }
      
      nstdin = 0;
      ptr = stdin_ptr[nstdin_ptr];
      while( nstdin < stdin_size && (c = getc(stdin)) != EOF ) {
	*ptr++ = c;
	nstdin++;
	flen++;
      }
      nstdin_ptr++;
      /* printf("nstdin : %d\n", nstdin);*/
    }

    if ( nstdin_ptr == 1 ) {	/*   calloc Ǵ֤ˤä  */
      if ( !flen ) {
	fprintf(stderr, "ɸϤɤ߹ߤޤ\n");
	exit (0);
      }
      oldptr = startptr = stdin_ptr[0];
    } else {			/*  Ĥ calloc 򣱤ĤˤޤȤ  */
      if ( !(startptr = calloc(1, flen + 1))) {
	fprintf(stderr, "<<<  Out of Memory (stdin)  >>>\n");
	exit (4);
      }
 
      ptr = startptr;
      for ( i = 0 ; i < nstdin_ptr - 1 ; i++ ) {
	memcpy(ptr, stdin_ptr[i], stdin_size);
	free(stdin_ptr[i]);
	ptr += stdin_size;
      }
      memcpy(ptr, stdin_ptr[i], nstdin);
      free(stdin_ptr[i]);
      oldptr = startptr;
      /* printf("nstdin_ptr : %d   flen : %d\n", nstdin_ptr, flen);*/
    }
  } else {			/*  ե뤫ɤ߹  */
    oldptr = startptr = GetSource(ipath);
  }

  /* ---- 97.9.2 */
  if ( cfflag == 0 ) {
    ptr = startptr;
    while (*ptr) {
      switch (*ptr) {
      case ' ':
      case '\n':
      case '\t':
	ptr++;
	continue;

      default:
	goto JMP;
      }
    }
  JMP:
    if ( !strncmp(ptr, "/*", 2))
      cfflag = 3;
  }

  /********************************  plist   ****    ***********/
  /*  եβιԿ  */
  endptr = startptr + flen;
  ptr = startptr;
  while ( ptr < endptr ) {
    if ( *ptr == '\n' )
      nplist++;
    ptr++;
  }

  /*  Ǹ夬 '\n' ǽäƤʤ Կ++  */
  if ( *(ptr-1) != '\n' ) {
    nplist++;
    *ptr = '\n';		/*  Ū '\n' Ĥ  */
  }

  if ( !(plist = calloc(nplist, sizeof(char **)))) {
    fprintf(stderr, "<<<  Out of Memory (plist)  >>>\n");
    exit (4);
  }
  /********************************  plist   ****  ޤ  ***********/

  fsize = nplist = 0;
  ptr = startptr;
  while ( fsize < flen ) {
    if ( (ptr = memchr(ptr, '\n', 1024))) {
      *ptr = 0;
      orgoldptr = oldptr;
      orgptr = ptr;
      tabflag = 0;
      if ( strchr(oldptr, '\t')) {
	tabspc(oldptr, string, tab);
	oldptr = calloc(1, strlen(string) + 1);
	if ( oldptr == NULL ) {
	  fprintf(stderr, "<<<  Out of Memory (tab)  >>>\n");
	  exit (4);
	}
	strcpy(oldptr, string);
	tabflag = 1;
	ptr = oldptr + strlen(oldptr);
      }

      if ( ptr < oldptr )
	break;
      ptr1 = oldptr;
      flag = col = 0;
      while ( ptr1 < ptr ) {
	if ( *ptr1 == 0 ) {
	  *ptr1 = 'n';
	  nulls++;
	  if ( !flag ) {
	    if ( !(new_null = calloc(1, sizeof(struct null_table)))) {
	      fprintf(stderr, "<<<  Out of Memory (null)  >>>\n");
	      exit (4);
	    }
	    if ( first_null == NULL ) {
	      first_null = new_null;
	      old_null = new_null;
	    } else {
	      old_null->next = new_null;
	      old_null = new_null;
	    }
	    new_null->start_row = nplist;
	    new_null->start_col = col;
	    flag = 1;
	  }
	} else if ( flag ) {
	  new_null->end_row = nplist;
	  new_null->end_col = col - 1;
	  npntbl++;
	  flag = 0;
	}
	col++;
	ptr1++;
      }
      if ( flag ) {
	new_null->end_row = nplist;
	new_null->end_col = col - 1;
	flag = 0;
	npntbl++;
      }

      plist[nplist++] = oldptr;
      i = strlen(oldptr) + 1;
      if ( ketamax < i )
	ketamax = i;
      /*
	 if ( tabflag ) {
	 oldptr = orgoldptr + strlen(orgoldptr) + 1;
	 ptr = orgptr;
	 } else
	 oldptr = ++ptr;
	 */
      ptr = orgptr + 1;
      oldptr = orgptr + 1;
      fsize += orgptr - orgoldptr + 1;
    } else {
	fprintf(stderr, "\x07ԤĹ 1024 byteۤΤɤ߹ߤߤޤ\n");
	exit (4);
    }
  }

  if ( nulls ) {
    printf("null character %d\n", nulls);
  }

  /*  C   */
  if ( cfflag == 2 || cfflag == 3 ) {
    flag = 0;
    for ( i = 0 ; i < nplist ; i++) {
      ptr = plist[i];
    loop:
      if ( !flag ) {            /*  ȡϤޤ  */
	ptr1 = ptr;             /* " Υå  */
	if ((ptr = strstr(ptr, "/*"))) {
	  if ((ptr1 = strstr(ptr1, "\""))) {
	    if ( ptr1 < ptr ) {
	      if ((ptr1 = strstr(++ptr1, "\""))) {
		ptr = ++ptr1;
		goto loop;
	      }
	    }
	  }

	  if ( !(new_comment = calloc(1, sizeof(struct comment_table)))) {
	    fprintf(stderr, "<<<  Out of Memory (comment)  >>>\n");
	    exit (4);
	  }
	  if ( first_comment == NULL ) {
	    first_comment = new_comment;
	    old_comment = new_comment;
	  } else {
	    old_comment->next = new_comment;
	    old_comment = new_comment;
	  }
	  new_comment->start_row = i;
	  new_comment->start_col = ptr - plist[i];
	  ptr += 2;
	  flag = 1;
	}
      }

      if ( flag ) {
	if ((ptr = strstr(ptr, "*/"))) { /*  ȡ  */
	  new_comment->end_row = i;
	  new_comment->end_col = ptr - plist[i] + 1;
	  ptr += 2;
	  flag = 0;
	  npctbl++;
	  if ( strstr(ptr, "/*") )
	    goto loop;
	}
      }
    }
  }

  line_keta = log10((double)nplist) + 1;
  lWidth = nFontWidth * (line_keta + 1);

  if ( npntbl ) {
    if ( !(pntbl = calloc(npntbl, sizeof(char **)))) {
      fprintf(stderr, "<<<  Out of Memory (pntbl) >>>\n");
      exit (4);
    }
    current_null = first_null;
    for ( i = 0 ; i < npntbl ; i++ ) {
      pntbl[i] = (char *)current_null;
      current_null = current_null->next;
    }
  }

  if ( npctbl ) {
    if ( !(pctbl = calloc(npctbl, sizeof(char **)))) {
      fprintf(stderr, "<<<  Out of Memory (pctbl) >>>\n");
      exit (4);
    }
    current_comment = first_comment;
    for ( i = 0 ; i < npctbl ; i++ ) {
      pctbl[i] = (char *)current_comment;
      /*
	 printf("%d : %d - %d     %d - %d\n", i,
	 current_comment->start_row,
	 current_comment->start_col,
	 current_comment->end_row,
	 current_comment->end_col);
	 */
      current_comment = current_comment->next;
    }
  }
}


/* ////////////////////////////////////////////////////////////////////////////
////           GetSource                                                   ////
//////////////////////////////////////////////////////////////////////////// */
int     GetFileLen();

char    *GetSource (fileptr)
char    *fileptr;
{
  static char     *retbuff;
  int     fd;

  if ( (fd = open (fileptr, O_RDONLY)) < 0 ) {
    fprintf(stderr, "Cannot open file %s\n", fileptr);
    exit (4);
  }

  flen = GetFileLen(fd);
  retbuff = (char * ) calloc (1, flen + 1);
  if ( read (fd, retbuff, flen) <= 0 ) {
    fprintf (stderr, "Error reading file %s\n", fileptr);
    return ((char *) NULL);
  }

  close (fd);
  return (retbuff);
}


/* ////////////////////////////////////////////////////////////////////////////
////           GetFileLen                                                  ////
//////////////////////////////////////////////////////////////////////////// */
GetFileLen (fd)
int     fd;
{
  static int      retval;

  lseek (fd, 0, L_SET);
  retval = lseek (fd, 0, L_XTND);
  lseek (fd, 0, L_SET);
  return (retval);
}


/* ////////////////////////////////////////////////////////////////////////////
////           disp_reserve()   ͽɽ                                 ////
//////////////////////////////////////////////////////////////////////////// */
void disp_reserve(int yy, char *pline, char *reserve[], char *color)
{
  int i, xx, len, flag;
  char *ptr;

  XSetForeground(pDisplay, gc, MyColor(pDisplay, color));
  i = 0;
  while ( reserve[i] ) {
    len = strlen(reserve[i]);
    ptr = pline;
    while ( ptr = strstr(ptr, reserve[i])) {
      flag = 0;

      if ( ptr == pline ) {
        if ( isspace(*(ptr + len)) || iscntrl(*(ptr + len)))
          flag = 1;
      } else {
        if ( isspace(*(ptr - 1)) || ispunct(*(ptr - 1)))
          if ( iscntrl(*(ptr + len)) || isspace(*(ptr + len)) || \
	      ispunct(*(ptr + len)))
            flag = 1;
      }
      if ( flag ) {
        xx = ptr - pline + x_offset;
        DrawText(xx, yy, ptr, len);
      }
      ptr += len;
    }
    i++;
  }
}


/* ////////////////////////////////////////////////////////////////////////////
////            ucase    ѾʸʸѴ                            ////
////            lcase    ʸʸѴ                            ////
//////////////////////////////////////////////////////////////////////////// */
void ucase(ptr, nlen)
     char    *ptr;
     int     nlen;
{
  int     i;
  
  for ( i=0 ; i<nlen ; i++, ptr++ ) {
    if ( *ptr >= 'a' && *ptr <= 'z' ) {
      *ptr = *ptr - ('a' - 'A');
    }
  }
}

void lcase(ptr, nlen)
     char    *ptr;
     int     nlen;
{
  int     i;

  for ( i=0 ; i<nlen ; i++, ptr++ ) {
    if ( *ptr >= 'A' && *ptr <= 'Z' ) {
      *ptr = *ptr + ('a' - 'A');
    }
  }
}


/* ////////////////////////////////////////////////////////////////////////////
////         strstr_ul                                                     ////
//////////////////////////////////////////////////////////////////////////// */
char *strstr_ul(char *str1, char *str2)
{
  char string1[BUFSIZE], string2[BUFSIZE];
  char *ptr;

  strcpy(string1, str1);
  strcpy(string2, str2);
  lcase(string1, strlen(string1));
  lcase(string2, strlen(string2));
  if ( ptr = strstr(string1, string2))
    ptr = ptr - string1 + str1;
  return ptr;
}


/* ////////////////////////////////////////////////////////////////////////////
////         disp_data_line();                                             ////
//////////////////////////////////////////////////////////////////////////// */
#define TRUE 1
#define FALSE 0

void disp_data_line(int no, int yy)
{
  int col, xx, j, n, len, flag, i, true;
  char        *ptr;
  char        string[BUFSIZE], string1[BUFSIZE];
  char  fmt[10];
  struct comment_table *current_comment;
  struct null_table *current_null;

  xx = x_offset;
  col = 0;
  strcpy(string, plist[no]);

  if ( cfflag == 0 ) {
    ptr = string;
    while ( *ptr ) {
      /*	  if ( isspace(*ptr) )*/
      if ( *ptr != ' ' ) 
	break;
      ptr++;
    } 

    if ( *ptr == '!' || *ptr == '#' || *ptr == ';' || *ptr == '|' || \
	*ptr == '\'' || *ptr == '>' || *ptr == ':' || *ptr == '+' || \
	*ptr == '*'  || \
	!strncmp(ptr, "", 2) || !strncmp(ptr, "", 2)  || \
	!strncmp(ptr, "", 2) || !strncmp(ptr, "", 2)) {
      XSetForeground(pDisplay, gc, ncgcolor);
      DrawText(xx, yy, string, ALL);
      xx += strlen(string);
    } else {
      for ( j = 0 ; j < npntbl ; j++) {
	/*  NULL    */
	current_null = (struct null_table *)pntbl[j];
	if ( no == current_null->start_row ) {
	  if ( 0 < current_null->start_col ) { /*  NULL ޤǽ */
	    n = current_null->start_col - col;
	    XSetForeground(pDisplay, gc, nfgcolor);
	    DrawText(xx, yy, string + col, n);
	    xx += n;
	    col += n;
	  }

	  n = current_null->end_col - current_null->start_col + 1;
	  XSetForeground(pDisplay, gc, nngcolor);
	  DrawText(xx, yy, string + col, n);
	  xx += n;
	  col += n;

	  /*    */
	  true = FALSE;
	  if ( j+1 < npntbl ) {
	    current_null = (struct null_table *)pntbl[j+1];
	    if ( no != current_null->start_row)
	      true = TRUE;
	  }

	  if ( j == npntbl-1 || true ) {
	    if ( col < strlen(string) ) { /*  NULL ʹߤ  */
	      n = strlen(string + col);
	      XSetForeground(pDisplay, gc, nfgcolor);
	      DrawText(xx, yy, string + col, n);
	      xx += n;
	    }
	    break;
	  }
	}
      }
      /*  NULL ʤ  */
      if ( j == npntbl ) {
	XSetForeground(pDisplay, gc, nfgcolor);  /* 97.9.3 */
	if ( ptr = strchr(string, '#')) {
	  i = ptr - string;
	  DrawText(xx, yy, string, i);
	  xx += i;
	  XSetForeground(pDisplay, gc, ncgcolor);
	  DrawText(xx, yy, ptr, ALL);
	  xx += strlen(ptr);
	} else {
	  XSetForeground(pDisplay, gc, nfgcolor);
	  DrawText(xx, yy, string, ALL);
	  xx += strlen(string);
	}
      }
    }
  }

  if ( cfflag == 1 ) {
    ptr = string;
    if ( *ptr == 'C' || *ptr == 'c' || *ptr == '*' )
      XSetForeground(pDisplay, gc, ncgcolor);
    else
      XSetForeground(pDisplay, gc, nfgcolor);
    DrawText(xx, yy, string, ALL);
    xx += strlen(string);
  }

  if ( cfflag == 2 || cfflag == 3 ) {
    for ( j = 0 ; j < npctbl ; j++) {
      /*  Comment    */
      current_comment = (struct comment_table *)pctbl[j];
      if ( no >= current_comment->start_row && no <= current_comment->end_row ) {
	if ( no == current_comment->start_row ) {
	  if ( 0 < current_comment->start_col ) { /*  Comment ޤǽ */
	    n = current_comment->start_col - col;
	    XSetForeground(pDisplay, gc, nfgcolor);
	    DrawText(xx, yy, string + col, n);
	    xx += n;
	    col += n;
	  }
	}

	/*  Comment ʣԤ˺ǽԤԤޤǽ  */
	if ( no < current_comment->end_row ) {
	  n = strlen(string + col);
	  XSetForeground(pDisplay, gc, ncgcolor);
	  DrawText(xx, yy, string + col, n);
	  xx += n;
	  col += n;
	}

	if ( no == current_comment->end_row ) { /*  Comment κǽԤ */
	  if ( no == current_comment->start_row )
	    n = current_comment->end_col - current_comment->start_col + 1;
	  if ( no >  current_comment->start_row )
	    n = current_comment->end_col + 1;
	  XSetForeground(pDisplay, gc, ncgcolor);
	  DrawText(xx, yy, string + col, n);
	  xx += n;
	  col += n;
	}

	/*    */
	true = FALSE;
	if ( j+1 < npctbl ) {
	  current_comment = (struct comment_table *)pctbl[j+1];
	  if ( no != current_comment->start_row)
	    true = TRUE;
	}

	if ( j == npctbl-1 || true ) {
	  if ( col < strlen(string) ) {	/*  Comment ʹߤ  */
	    n = strlen(string + col);
	    XSetForeground(pDisplay, gc, nfgcolor);
	    DrawText(xx, yy, string + col, n);
	    xx += n;
	  }
	  break;
	}
      }
    }

    /*  No_Comment    */
    if ( j == npctbl ) {
      XSetForeground(pDisplay, gc, nfgcolor);
      DrawText(xx, yy, string, ALL);
      xx += strlen(string);
    }
  }

  /*  ʸɽ  */
  if ( crflag ) {
    XSetForeground(pDisplay, gc, nagcolor);
    DrawText(xx, yy, "'", ALL);
  }

  /*  ʸɽ  */
  XSetForeground(pDisplay, gc, nfgcolor);
  for ( i = 0 ; i < 12 ; i++ ) {
    if ( nfind[i] ) {
      ptr = string;
      while ( ptr = strstr_ul(ptr, find[i])) {
	XSetBackground(pDisplay, gc, nigcolor[i]);
	xx = ptr - string + x_offset;
	DrawImageText(xx, yy, ptr, nfind[i]);
	ptr += nfind[i];
      }
    }
  }

  /*  ͽɽ  */
  if ( cfflag == 1 ) {		/*  ƣ  */
    disp_reserve(yy, string, F_reserve1, "RoyalBlue");
    disp_reserve(yy, string, F_reserve2, "ForestGreen");
    disp_reserve(yy, string, F_reserve3, "purple");
  } else if ( cfflag == 2 ) {	/*    */
    disp_reserve(yy, string, C_reserve1, "RoyalBlue");
    disp_reserve(yy, string, C_reserve2, "ForestGreen");
    disp_reserve(yy, string, C_reserve3, "purple");
  }

  /*  ֹɽ  */
  xx = 0;
  XSetForeground(pDisplay, gc, nlgcolor);
  sprintf(fmt, "%%%dd", line_keta);
  sprintf(string, fmt, no + 1);
  DrawText2(xx, yy, string, ALL);
}


/* ////////////////////////////////////////////////////////////////////////////
////           selline_draw()   򤵤줿եֹɽ             ////
////                                   selline ͤɽ                  ////
//////////////////////////////////////////////////////////////////////////// */
void selline_draw()
{
        int     xx, yy, nWid, nHei;
        char    outbuf[80];

        xx = nFontWidth * xx_selline;
        yy = 0;
        nWid = nFontWidth * 20;
        nHei = nFontHeight;
        XClearArea(pDisplay, w1, xx, yy, nWid, nHei, False);

        XSetForeground(pDisplay, gc, nhgcolor);
        sprintf(outbuf, "%d / %d", selline+1, nplist);
        DrawText(xx_selline, yy, outbuf, ALL);
}


/* ////////////////////////////////////////////////////////////////////////////
////            select_file                                                ////
////            򤵤줿ե£ϣؤǰϤ                           ////
//////////////////////////////////////////////////////////////////////////// */
void select_file(unsigned long int color)
{
  int     i, j, xx, yy, nWid, nHei;
  static int dis_cursor_old = 0;
  static int sflag_old = 0;
  static int dash_flag = 0;
  static char dash[20];
  unsigned int linew;

  /*  å  */
  if ( !dash_flag ) {
    for ( i = j = 0 ; i < 4 ; i++ ) {
      dash[j++] = 1;
      dash[j++] = nFontWidth - 1;
    }
    dash[j-1] = nFontWidth - 2;
    dash[j++] = 2;
    dash[j++] = nFontWidth - 1;

    for ( i = 0 ; i < 4 ; i++ ) {
      dash[j++] = 1;
      dash[j++] = nFontWidth - 1;
    }
    dash[j-1] = nFontWidth - 2;
    dash[j++] = 3;
    dash[j++] = nFontWidth - 2;
    dash_flag = 1;
  }

  /*  õ  */
  XSetForeground(pDisplay, gc, nbgcolor);
  nWid = uWidth - 2;
  if ( lineflag )
    nWid -= lWidth;

  linew = 1;
  if ( sflag_old >= 2 )
    linew = 2;
    
  nHei = nFontHeight;
  if ( sflag_old == 1 || sflag_old == 3 ) { /*    */
    xx = nFontWidth / 2 + 1;
    yy = nFontHeight * (dis_cursor_old + 2) + 1;
    XSetDashes(pDisplay, gc, 0, dash, 20);
    XSetLineAttributes(pDisplay, gc, linew, LineOnOffDash, CapButt, JoinMiter);
    XDrawLine(pDisplay, w1, gc, xx, yy, nWid, yy);
  } else {			/*  £ϣ  */
    xx = 0;
    yy = nFontHeight * (dis_cursor_old + 1) + 1;
    XSetLineAttributes(pDisplay, gc, linew, LineSolid, CapButt, JoinMiter);
    XDrawRectangle(pDisplay, w1, gc, xx, yy, nWid, nHei);
  }

  if ( color == nbgcolor ) {
    return;
  }

  /*    */
  linew = 1;
  if ( sflag >= 2 )
    linew = 2;

  XSetForeground(pDisplay, gc, nsgcolor);
  if ( sflag == 1 || sflag == 3 ) { /*    */
    xx = nFontWidth / 2 + 1;
    yy = nFontHeight * (dis_cursor + 2) + 1;

    XSetDashes(pDisplay, gc, 0, dash, 20);
    XSetLineAttributes(pDisplay, gc, linew, LineOnOffDash, CapButt, JoinMiter);
    XDrawLine(pDisplay, w1, gc, xx, yy, nWid, yy);
  } else {			/*  £ϣ  */
    xx = 0;
    yy = nFontHeight * (dis_cursor + 1) + 1;
    XSetLineAttributes(pDisplay, gc, linew, LineSolid, CapButt, JoinMiter);
    XDrawRectangle(pDisplay, w1, gc, xx, yy, nWid, nHei);
  }
  dis_cursor_old = dis_cursor;
  sflag_old = sflag;
}


/* ////////////////////////////////////////////////////////////////////////////
////          disp_data();                                                 ////
//////////////////////////////////////////////////////////////////////////// */
void disp_data()
{
  int     xx, yy, i ;
  char    outbuf[81];

  if ( !expose_flag ) {
    XClearWindow(pDisplay, w1);
    XClearWindow(pDisplay, w2);
  }

  xx = 0;
  yy = 0;

  for ( i = 0 ; i < 80 ; i++)
    outbuf[i] = ' ';

  /* ----------------------------------------------  Name  --------- */
  XSetForeground(pDisplay, gc, nfgcolor);
  DrawText(xx, yy, "Name:", ALL);
  xx += 5;

  XSetForeground(pDisplay, gc, nhgcolor);
  DrawText(xx, yy, label, ALL);
  xx += strlen(label) + 1;

  /* ----------------------------------------------  Column  ------- */
  XSetForeground(pDisplay, gc, nfgcolor);
  DrawText(xx, yy, "Column:", ALL);
  xx += 7;

  XSetForeground(pDisplay, gc, nhgcolor);
  sprintf(outbuf, "%d / %d", abs(x_offset)+1, ketamax-1);
  DrawText(xx, yy, outbuf, ALL);
  xx += strlen(outbuf) + 1;
  xx_selline = xx;

  XSetForeground(pDisplay, gc, nfgcolor);
  sprintf(outbuf, "Line:");
  DrawText(xx, yy, outbuf, ALL);
  xx += strlen(outbuf);
  xx_selline = xx;
  dis_lines = QLines() - 1;
  dis_msg = QLines() - 1;
  dis_bottom = dis_top + dis_lines;
  if ( dis_bottom > nplist )
    dis_bottom = nplist;

  for ( yy = 1, i = dis_top  ; i < dis_bottom ; i++, yy++)
    disp_data_line(i, yy);

  if ( dis_cursor >= dis_msg ) /* ɡ򾮤ν */
    dis_cursor = dis_msg - 1;

  selline = dis_top + dis_cursor;
  if ( selline > nplist - 1 ) {
    selline = nplist - 1;
    dis_cursor = dis_bottom - dis_top - 1;
    curyy = dis_cursor + 0;
  }
  if ( csrflag )
    select_file(nsgcolor);
  selline_draw();
}


/* ////////////////////////////////////////////////////////////////////////////
////           ClearTextArea()  ǤդκɸꤷΥƥȤä ////
//////////////////////////////////////////////////////////////////////////// */
void ClearTextArea(w, xx, yy, keta)
Window  w;
int     xx, yy, keta;
{
  int     xx1, yy1, nWid, nHei;
  xx1 = nFontWidth * xx;
  yy1 = nFontHeight * yy + 1;
  nWid = nFontWidth * keta;
  nHei = nFontHeight + 0;
  XClearArea(pDisplay, w, xx1, yy1, nWid, nHei, False);
}

/* ////////////////////////////////////////////////////////////////////////////
////           ClearTextArea2() ǤդκɸꤷΥƥȤä ////
////                           search mode Τ߻                        ////
//////////////////////////////////////////////////////////////////////////// */
void ClearTextArea2(w, xx, yy, keta)
     Window  w;
     int     xx, yy, keta;
{
  int     xx1, yy1, nWid, nHei;
  xx1 = nFontWidth * xx + 1;
  yy1 = nFontHeight * yy + 2;
  nWid = nFontWidth * keta;
  nHei = nFontHeight - 1;
  XClearArea(pDisplay, w, xx1, yy1, nWid, nHei, False);
}


/* ////////////////////////////////////////////////////////////////////////////
////           scroll_up                                                   ////
//////////////////////////////////////////////////////////////////////////// */
void scroll_up()
{
  int     src_x, src_y, dest_x, dest_y;
  unsigned int    width, height;

  select_file(nbgcolor);
  src_x = 0;
  src_y = nFontHeight * 1 + 1;
  width = uWidth;
  height = (dis_lines - 1) * nFontHeight + 0;
  dest_x = 0;
  dest_y = nFontHeight * 2 + 1;
  XCopyArea(pDisplay, w1, w1, gc, src_x, src_y, width, height, dest_x, dest_y);
  XCopyArea(pDisplay, w2, w2, gc, src_x, src_y, width, height, dest_x, dest_y);
  return;
}


/* ////////////////////////////////////////////////////////////////////////////
////           cursor_up                                                   ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_up()
{
  int     yy = 1;
  
  if ( dis_cursor == 0 ) {
    if ( dis_top > 0 ) {
      select_file(nbgcolor);
      dis_top--;
      dis_bottom--;
      selline--;
      scroll_up();
      
      yy = 1;
      ClearTextArea(w1, 0, yy, ketamax);
      ClearTextArea(w2, 0, yy, ketamax);
      disp_data_line(selline, yy);
      select_file(nsgcolor);
      selline_draw();
    }
    return;
  }
  
  --dis_cursor;
  --selline;
  select_file(nsgcolor);
  selline_draw();
}


/* ////////////////////////////////////////////////////////////////////////////
////           cursor_top                                                  ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_top()
{
  if ( dis_cursor == 0 ) {
    if ( dis_top != 0 ) {
      dis_top -= dis_lines;
      if ( dis_top < 0 )
	dis_top = 0;
      disp_data();
    }
    return;
  }
  
  selline -= dis_cursor;
  curyy  -= dis_cursor;
  dis_cursor = 0;
  select_file(nsgcolor);
  selline_draw();
}


/* ////////////////////////////////////////////////////////////////////////////
////           scroll_down                                                 ////
//////////////////////////////////////////////////////////////////////////// */
void scroll_down()
{
  int     src_x, src_y, dest_x, dest_y;
  unsigned int    width, height;

  select_file(nbgcolor);
  src_x = 0;
  src_y = nFontHeight * 2 + 1;
  width = uWidth;
  height = (dis_lines - 1) * nFontHeight + 0;
  dest_x = 0;
  dest_y = nFontHeight + 1 ;
  XCopyArea(pDisplay, w1, w1, gc, src_x, src_y, width, height, dest_x, dest_y);
  XCopyArea(pDisplay, w2, w2, gc, src_x, src_y, width, height, dest_x, dest_y);
  return;
}


/* ////////////////////////////////////////////////////////////////////////////
////           cursor_down                                                 ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_down()
{
  int     yy;

  dis_bottom = dis_top + dis_lines;
  if ( dis_bottom > nplist )
    dis_bottom = nplist;
  if ( selline == dis_bottom - 1 ) {
    if ( (dis_top + dis_lines) < nplist ) {
      select_file(nbgcolor);
      dis_top++;
      selline++;
      dis_bottom++;
      scroll_down();
      yy = dis_lines;
      ClearTextArea(w1, 0, yy, ketamax);
      ClearTextArea(w2, 0, yy, ketamax);
      disp_data_line(selline, yy);
      selline_draw();
      select_file(nsgcolor);
    }
    return;
  }

  ++dis_cursor;
  ++selline;
  select_file(nsgcolor);
  selline_draw();
}


/* ////////////////////////////////////////////////////////////////////////////
////           cursor_bottom                                               ////
//////////////////////////////////////////////////////////////////////////// */
void cursor_bottom()
{
  int     i;

  dis_bottom = dis_top + dis_lines;
  if ( dis_bottom > nplist )
    dis_bottom = nplist;

  if ( selline == dis_bottom - 1 ) {
    if ( (dis_top + dis_lines) < nplist ) {
      dis_top += dis_lines;
      disp_data();
    }
    return;
  }

  i = dis_bottom - dis_top - dis_cursor - 1;
  dis_cursor += i;
  selline += i;
  curyy += i;
  select_file(nsgcolor);
  selline_draw();
}


/* ////////////////////////////////////////////////////////////////////////////
////           ClearText()     ֤ˤƥȤä            ////
//////////////////////////////////////////////////////////////////////////// */
void ClearText(xx, yy)
int     xx, yy;
{
  int     xx1, yy1, nWid, nHei;
  xx1 = nFontWidth * xx + 1;
  yy1 = nFontHeight * yy + 2;
  nWid = nFontWidth;
  nHei = nFontHeight - 1;
  XClearArea(pDisplay, w1, xx1, yy1, nWid, nHei, False);
}


/* ////////////////////////////////////////////////////////////////////////////
////           retcode_disp()            ʸɽɽ              ////
//////////////////////////////////////////////////////////////////////////// */
void retcode_disp(color)
unsigned long int       color ;
{
  int     xx, yy, i;
  XSetForeground(pDisplay, gc, color);

  dis_bottom = dis_top + dis_lines;
  if ( dis_bottom > nplist )
    dis_bottom = nplist;
  for ( yy = 1, i = dis_top  ; i < dis_bottom ; i++, yy++) {
    xx = strlen(plist[i]) + x_offset;
    DrawText(xx, yy, "'", ALL);
  }
}


/* ////////////////////////////////////////////////////////////////////////////
///            search_input                                                ////
//////////////////////////////////////////////////////////////////////////// */
void    search_input()
{
  /*  ʸꥢ  */
  ClearTextArea2(w1, 0, dis_msg, ketamax);
  XSetForeground(pDisplay, gc, nfgcolor);
  XSetBackground(pDisplay, gc, nigcolor[findex]);
  DrawImageText(0, dis_msg, find[findex], ALL);

  if ( !nfind[findex] ) {
    XSetForeground(pDisplay, gc, nigcolor[findex]);
    DrawText(0, dis_msg, "Search mode", ALL);
  }
}

/* ////////////////////////////////////////////////////////////////////////////
///            handleKeyboard                                              ////
//////////////////////////////////////////////////////////////////////////// */
void    handleKeyboard()
{
  int i , j, code;
  char        buffer [MAXLINE];
  char        *pt;

  buffer[0] = 0;
  XLookupString(&report.xkey, buffer, MAXLINE, &myKeysym, &myStatus);

  switch (myKeysym) {
  case XK_Shift_L:		/*  Shift  */
  case XK_Shift_R:
    if ( shiftflag == 0 )
      shiftflag = 1;
    break;

  case XK_Control_L:		/* Control */
  case XK_Control_R:
    if ( ctrlflag == 0 )
      ctrlflag = 1;
    break;

  case XK_F1:			/*  F1  */
    findex = 0;
    search_input();
    break;

  case XK_F2:			/*  F2  */
    findex = 1;
    search_input();
    break;

  case XK_F3:			/*  F3  */
    findex = 2;
    search_input();
    break;

  case XK_F4:			/*  F4  */
    findex = 3;
    search_input();
    break;

  case XK_F5:			/*  F5  */
    findex = 4;
    search_input();
    break;

  case XK_F6:			/*  F6  */
    findex = 5;
    search_input();
    break;

  case XK_F7:			/*  F7  */
    findex = 6;
    search_input();
    break;

  case XK_F8:			/*  F8  */
    findex = 7;
    search_input();
    break;

  case XK_F9:			/*  F9  */
    findex = 8;
    search_input();
    break;

  case XK_F10:			/*  F10  */
    findex = 9;
    search_input();
    break;

  case XK_F11:			/*  F11  */
    findex = 10;
    search_input();
    break;

  case XK_F12:			/*  F12  */
    if ( shiftflag ) {		/*  refresh  */
      for ( i = 0 ; i < nplist ; i++ )
        free(plist[i]);
      nplist = 0;

      Read_Data();
    } else {
      findex = 11;
      search_input();
    }
    break;

  case XK_Return:		/*  Return  */
    if ( shiftflag ) {		/*  ظ  */
      if ( nfind[findex] ) {
	for ( i = dis_top - 1 ; i >= 0 ; i--) {
	  if ( strstr_ul(plist[i], find[findex]) ) {
	    dis_top = i;
	    disp_data();
	    break;
	  }
	}
	if ( 0 > i )
	  printf("\x07'%s' is not found.\n", find[findex]);
      }
    } else  if ( nfind[findex] ) { /*  ظ  */
      for ( i = dis_top + 1 ; i < nplist ; i++) {
	if ( strstr_ul(plist[i], find[findex]) ) {
	  dis_top = i;
	  disp_data();
	  break;
	}
      }
      if ( nplist == i )
	printf("\x07'%s' is not found.\n", find[findex]);
    }
    break;

  case XK_BackSpace:		/* BackSpace */
    if ( nfind[findex] ) {
      ClearText(--nfind[findex], dis_msg);
      find[findex][nfind[findex]] = 0;
    }
    break;

  case XK_Escape:		/* Escape */
    Quit();
    break;

  case XK_Prior:		/* Page Up */
    if ( dis_top != 0 ) {
      dis_top -= dis_lines;
      if ( dis_top < 0 )
	dis_top = 0;
      disp_data();
    } else
      cursor_top();
    break;

  case XK_Next:			/* Page Down */
    if ( (dis_top + dis_lines) < nplist ) {
      dis_top += dis_lines;
      disp_data();
    } else
      cursor_bottom();
    break;

  case XK_Home:			/* Top */
    if ( dis_top ) {
      dis_top = 0;
      disp_data();
      cursor_top();
    } else
      cursor_top();
    break;

  case XK_End:			/* Bottom */
    if ( (nplist - dis_lines) != dis_top ) {
      if ( nplist > dis_lines ) {
	dis_top = nplist - dis_lines;
	disp_data();
      }
      cursor_bottom();
    } else
      cursor_bottom();
    break;

  case XK_Up:			/* Cursor Up */
    if ( shiftflag )
      cursor_top();
    else
      cursor_up();
    break;

  case XK_Down:			/* Cursor Down */
    if ( shiftflag )
      cursor_bottom();
    else
      cursor_down();
    csrflag = 1;
    break;

  case XK_Left:			/* Cursor Left */
    if ( x_offset ) {
      if ( shiftflag )
	x_offset += 100;
      else
	x_offset += 10;
      if ( x_offset > 0 )
	x_offset = 0;
      disp_data();
    }
    break;

  case XK_Right:		/* Cursor Right */
    if ( shiftflag )
      x_offset -= 100;
    else
      x_offset -= 10;
    disp_data();
    break;

  default:
    if ( ctrlflag ) {
      switch (myKeysym) {
      case 'z':			/*  ֹ ɽɽ  */
	lineflag = ~lineflag;
	if ( lineflag ) {
	  uWidth += lWidth;
	  XResizeWindow(pDisplay, window, uWidth, uHeight);
	  XResizeWindow(pDisplay, w1, uWidth, uHeight);
	  XMoveWindow(pDisplay, w1, lWidth, 0);
	  XMapWindow(pDisplay, w2);
	} else {
	  XUnmapWindow(pDisplay, w2);
	  uWidth -= lWidth;
	  XResizeWindow(pDisplay, window, uWidth, uHeight);
	  XMoveWindow(pDisplay, w1, 0, 0);
	}
	break;

      case 'o':			/*  ʸɽɽ  */
	crflag = ~crflag;
	if ( !crflag )
	  retcode_disp(nbgcolor);
	else
	  retcode_disp(nagcolor);
	break;

      case 's':			/*  򤵤줿ե £ϣ   */
	sflag++;
	if ( sflag == 4 ) 
	  sflag = 0;
	select_file(nsgcolor);
	break;

      case 'v':			/*  vi editer ǳ 97.9.3  */
	sprintf(buffer, "%s -e %s +%d %s &", TERM, EDITER, selline + 1, ipath);
	printf("%s\n", buffer);
	system(buffer);
	return;

      default:
	break;
      }
    }

    if ( isprint(buffer[0]) ) {
      /*  ʸå  */
      find[findex][nfind[findex]] = buffer[0];
      nfind[findex]++;
      find[findex][nfind[findex]] = 0;
      ClearText(nfind[findex] - 1, dis_msg);
      XSetForeground(pDisplay, gc, nfgcolor);
      XSetBackground(pDisplay, gc, nigcolor[findex]);
      DrawImageText(0, dis_msg, find[findex], ALL);
    }
    break;
  }
}


/* ////////////////////////////////////////////////////////////////////////////
////            main                                                       ////
//////////////////////////////////////////////////////////////////////////// */
main(argc, argv, envp)
     int argc;
     char **argv;
     char **envp;
{
  char **pt = argv;
  char *ptr;
  Pixmap pixmap;
  unsigned int uNewHeight, uNewWidth;
  int i, label_flag = 0, offset = 0;
  XSizeHints      hints;
  Cursor          MyCursor;
  Window          winRoot;
  unsigned long int   wEventMask;

  /* --------------------  Parse command line : path font fg bg  --------- */
  strcpy(sFontName, FONT);
  strcpy(fgcolor  , FGCOLOR);
  strcpy(bgcolor  , BGCOLOR);
  strcpy(sgcolor  , SGCOLOR);
  strcpy(cgcolor  , CGCOLOR);
  strcpy(hgcolor  , HGCOLOR);
  strcpy(agcolor  , AGCOLOR);
  strcpy(ngcolor  , NGCOLOR);

  while ( *++pt ) {
    if ( !strcmp(*pt, "-fn")) {
      fontflag = 1;
      strcpy(sFontName, *++pt);
    } else if ( !strcmp(*pt, "-tab")) {
      tab = atoi(*++pt);
    } else if ( !strcmp(*pt, "-l")) {
      strcpy(label, *++pt);
      label_flag = 1;
    } else if ( !strcmp(*pt, "-m")) {
      stdin_size = atoi(*++pt);
    } else if ( !strcmp(*pt, "-fg")) {
      strcpy(fgcolor, *++pt);
    } else if ( !strcmp(*pt, "-bg")) {
      strcpy(bgcolor, *++pt);
    } else if ( !strcmp(*pt, "-sg")) {
      strcpy(sgcolor, *++pt);
    } else if ( !strcmp(*pt, "-cg")) {
      strcpy(cgcolor, *++pt);
    } else if ( !strcmp(*pt, "-ag")) {
      strcpy(agcolor, *++pt);
    } else if ( !strcmp(*pt, "-ng")) {
      strcpy(ngcolor, *++pt);
    } else if ( !strcmp(*pt, "-hg")) {
      strcpy(hgcolor, *++pt);
    } else if ( !strcmp(*pt, "-c")) {
      cfflag = 2;
    } else if ( !strcmp(*pt, "-f")) {
      cfflag = 1;
    } else if ( !strcmp(*pt, "-J")) {
      jflag = 1;
    } else if ( !strcmp(*pt, "-L")) {
      lineflag = -1;
    } else if ( strstr(*pt, "-h")) {
      fprintf(stderr,
	      "usage: xbr filename\n  %s\n  options:\n" \
	      "    [-c (C mode)]\n" \
	      "    [-f (FORTRAN mode)]\n" \
	      "    [-fn Font]\n" \
	      "    [-J (japanese)]\n" \
	      "    [-l  label]\n" \
	      "    [-tab num]\n" \
	      "    [-bg Background Corol]\n" \
	      "    [-fg Foreground Color]\n" \
	      "    [-sg Selectfile Color]\n" \
	      "    [-cg Comment Color]\n" \
	      "    [-ag Returncode Color]\n" \
	      "    [-hg title Color]\n" \
	      "    [-ng null character Color]\n" \
	      "    [-L  (Line number)]\n" \
	      "    [-h  (help)]\n", VERSION);
      exit (0);
        } else {
            stdin_flag = 0;
            strcpy(ipath, *pt);           /* File Name */
            if ( !label_flag )
                strcpy(label, *pt);
        }
    }

    /* --------------------  cfflag set  ----------------------------------- */
    if ( cfflag == 0 ) {
        if ( stdin_flag && label_flag )
	  strcpy(ipath, label);
        i = strlen(ipath);
        if ( ptr = strrchr(ipath, '.')) {
          if ( strlen(ptr) == 2 ) {
            if ( *(ptr+1) == 'f' )
                cfflag = 1;
            else if ( *(ptr+1) == 'c' )
                cfflag = 2;
            else if ( *(ptr+1) == 'h' )
                cfflag = 2;
          }
        }
    }

    /* --------------------  Connect to X Server  -------------------------- */
    if ( !(pDisplay = XOpenDisplay(NULL))) {
        fprintf(stderr, "%s: cannot open %s\n", argv[0], XDisplayName(NULL));
        exit (4);
    }

    nScreen = DefaultScreen(pDisplay);
    winRoot = XDefaultRootWindow(pDisplay);

    /* --------------------  Setup Graphics Context  ----------------------- */
    gc = DefaultGC(pDisplay, nScreen);

    /* --------------------  Color Set  ------------------------------------ */
    color_define();

    /*---------------------  Font set  ------------------------------ */
    FontInfoSet();

    /* ----------------  Read_Data  --------------------------------------- */
    Read_Data();

    /* ------------------  XCreateSimpleWindow  --------------------------- */
    if ( lineflag )
        offset = lWidth;

    uWidth = nFontWidth * ketamax + offset + 3;
    if ( uWidth > DisplayWidth(pDisplay, 0)-20)
        uWidth = DisplayWidth(pDisplay, 0)-20;

    uHeight = nFontHeight * (nplist + 1) + 2;
    if ( uHeight > DisplayHeight(pDisplay, 0))
        uHeight = (DisplayHeight(pDisplay, 0) / nFontHeight - 2) * 
	          nFontHeight + 2; /* -2 window Ѥ;͵ */

    window = XCreateSimpleWindow(pDisplay, winRoot, 0, 0,
                                 uWidth, uHeight, 0, 0, nbgcolor);

    w1 = XCreateSimpleWindow(pDisplay, window, offset, 0,
                             uWidth, uHeight, 0, 0, nbgcolor);

    w2 = XCreateSimpleWindow(pDisplay, window, 0, 0,
                             lWidth, uHeight, 0, 0, nbgcolor);

    /* --------------------  Set hints to window manager  ------------------ */
    pixmap = XCreateBitmapFromData(pDisplay, window, xbr_bits,
                                   xbr_width, xbr_height);
    strcat(strcpy(outbuf, "xbr "), ipath);
    hints.flags = 0;
    XSetStandardProperties(pDisplay, window, outbuf, "xbr", pixmap,
                           argv, argc, &hints);

    /* --------------------  Change cursor to personal preference  --------- */
    MyCursor = XCreateFontCursor(pDisplay, XC_dotbox);
    XDefineCursor(pDisplay, window, MyCursor);

    /* --------------------  Select input events to moinitor  -------------- */
    wEventMask = ButtonPressMask | StructureNotifyMask | KeyPressMask |
                 ExposureMask | KeymapStateMask | KeyReleaseMask;

    XSelectInput(pDisplay, window, wEventMask);
    XSelectInput(pDisplay, w1, wEventMask);
    XSelectInput(pDisplay, w2, wEventMask);

    /* --------------------  Map window  ----------------------------------- */
    XMapWindow(pDisplay, window);
    XMapWindow(pDisplay, w1);
    if ( lineflag )
        XMapWindow(pDisplay, w2);

    /* --------------------  Enter infinite event loop  -------------------- */
    while (True) {
        XNextEvent (pDisplay, &report);
        switch (report.type) {
        case ButtonPress:
            switch ( report.xbutton.button ) {
            case Button3:
                Quit();
                break;
            }
            break;

        case KeyPress:
            handleKeyboard();
            break;

        case KeyRelease:
            if ( shiftflag == 1 ) {
                XLookupString(&report.xkey, outbuf, MAXLINE, &myKeysym, \
			      &myStatus);
                if ( myKeysym == XK_Shift_L || myKeysym == XK_Shift_R )
                    shiftflag = 0;
            }

            if ( ctrlflag == 1 ) {
                XLookupString(&report.xkey, outbuf, MAXLINE, &myKeysym, \
			      &myStatus);
                if ( myKeysym == XK_Control_L || myKeysym == XK_Control_R )
                    ctrlflag = 0;
            }
            break;

        case ConfigureNotify:
	    while ( XCheckTypedEvent(pDisplay, ConfigureNotify, &report));
            uNewHeight = report.xconfigure.height;
            uNewWidth  = report.xconfigure.width;
            if ((uNewHeight != uHeight) || (uNewWidth != uWidth) ) {
	      uWidth  = uNewWidth;
	      uHeight = uNewHeight / nFontHeight * nFontHeight + 2;
	      XResizeWindow(pDisplay, w1    , uWidth, uHeight);
/*  Ĥ򤸤ä Ȥޤʤ  */
/*	      XResizeWindow(pDisplay, window, uWidth, uHeight);*/
	    }

	    /*  ;פ expose 򤵤ʤ  */
	    while ( i=XEventsQueued(pDisplay, QueuedAfterFlush) > 0) {
	      XPeekEvent(pDisplay, &report);
	      if ( report.type != Expose )
		break;
	      XNextEvent(pDisplay, &report);
	    }

            while ( XCheckTypedEvent(pDisplay, Expose, &report));
	    if ( !report.xexpose.count ) {
	      expose_flag = 1;
	      disp_data();
	      expose_flag = 0;
	    }
            break;

        case Expose:
            while ( XCheckTypedEvent(pDisplay, Expose, &report));
	    if ( !report.xexpose.count ) {
	      expose_flag = 1;
	      disp_data();
	      expose_flag = 0;
	    }
            break;

	  case MapNotify:
	  case UnmapNotify:
            break;

        default:
            break;
        }
    }
}
