#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "define.h"
#include "lf.h"

/* ////////////////////////////////////////////////////////////////////////////
////            FunctionKey_list                                           ////
////            ޥɤɽ                                         ////
//////////////////////////////////////////////////////////////////////////// */
void FunctionKey_list(msg, cmd)
    char    *msg;
    char    *cmd[];
{
    int     i, yy;

    XClearWindow(pDisplay, window);
    XSetForeground(pDisplay, gc, nfgcolor);
    yy = 0;
    DrawText(1, yy, msg, ALL);
    yy = 2;

    for ( i = 0 ; i < 12 ; i++) {
        if ( cmd[i] ) {
            sprintf(buffer, "F%d = %s", i + 1, cmd[i]);
            DrawText(5, yy++, buffer, ALL);
        }
    }

    i = True;
    while (i) {
        XNextEvent (pDisplay, &report);
        switch (report.type) {
        case KeyPress:
            i = False;
        }
    }
}


/* ////////////////////////////////////////////////////////////////////////////
////            Environment_list                                           ////
////            ޥɤɽ                                         ////
//////////////////////////////////////////////////////////////////////////// */
void Environment_list()
{
    int     i, xx, yy;
    unsigned int   wHeight;

    XClearWindow(pDisplay, window);
    XSetForeground(pDisplay, gc, nfgcolor);

    /* ---------------------------------------  XResizeWindow  --------- */
    i = 0;
    while ( *(Mcmd + i) ) i++;
    i += 8;
    wHeight = nFontHeight * i + 2;
    if ( wHeight > uHeight ) {
        XResizeWindow(pDisplay, window, uWidth, wHeight);
        XNextEvent (pDisplay, &report);
    }

    /* ---------------------------------------  Mcommand  -------------- */
    xx = 1;
    yy = 0;
    DrawText(xx, yy++, "MCommand", ALL);
    DrawText(3, yy++, "Inside Command", ALL);
    DrawText(5, yy++, "e : File Erase", ALL);
    yy++;

    DrawText(3, yy++, "Outside Command", ALL);
    i = 0;
    while ( *(Mcmd + i) ) {
        sprintf(buffer, "%s", *(Mcmd + i++));
        DrawText(5, yy++, buffer, ALL);
    }
    DrawText(xx, yy, "New Window", ALL);
    sprintf(buffer, "!  : %s", windowenv1);
    DrawText(5, ++yy, buffer, ALL);
    sprintf(buffer, "!! : %s", windowenv2);
    DrawText(5, ++yy, buffer, ALL);

    i = True;
    while (i) {
        XNextEvent (pDisplay, &report);
        switch (report.type) {
        case KeyPress:
                i = False;
        }
    }

    /* --------------------------------------  Function key            */
    FunctionKey_list("Function key", fkcmd);

    /* --------------------------------------  Function key  (shift)   */
    FunctionKey_list("Function key (Shift)", skcmd);

    /* --------------------------------------  Function key  (ctrl)    */
    FunctionKey_list("Function key (Ctrl)", ckcmd);

    /* --------------------------------------  Function key  (alt)     */
    FunctionKey_list("Function key (Alt)", akcmd);

    if ( wHeight > uHeight )
        XResizeWindow(pDisplay, window, uWidth, uHeight);

    shift_flag = 0;
    lf_draw();
}
