#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include "define.h"
#define NOT_X
#include "lf.h"
#undef NOT_X

extern char *search_notspace();

/* ////////////////////////////////////////////////////////////////////////////
////            flagset                                                    ////
////            ptr1  ptr2 õ ʸκǸ˥̥ʸ       ////
//////////////////////////////////////////////////////////////////////////// */
char *flagset(ptr1, ptr2)
    char    *ptr1, *ptr2;
{
  char    *ret, *ptr;

  /*  ptr1 ʸΥ֤򥹥ڡ֤  */
  ptr = ptr1;
  while ( *ptr ) {
    if ( *ptr == '\t' )
      *ptr = ' ';
    ptr++;
  }

  /*  ڡɤФ  */
  ptr1 = search_notspace(ptr1);

  if ( *ptr1 == '#' )
    return NULL;

  /*  ptr1 ʸ ptr2 Ʊ  */
  if ( !(ptr1 == strstr(ptr1, ptr2))) {
    return NULL;
  }

  /*  ڡɤФ  */
  ptr1 += strlen(ptr2);
  ptr1 = search_notspace(ptr1);
  ret = ptr1;
  ptr = NULL;

  /*  ̥ʸΥݥ󥿡õ  */
  while ( *ptr1 ) {
    if ( *ptr1 == '#' || *ptr1 == 0x0a )
      break;
    else if ( *ptr1 == '"' )
      *ptr1 = ' ';
    else if ( *ptr1 == ' ' )
      if ( ptr == NULL )
	ptr = ptr1;
      else ;
    else
      ptr = NULL;
    ptr1++;
  }

  /*  ̥ʸ򥻥åȤ  */
  if ( ptr )
    *ptr = 0;
  else
    *ptr1 = 0;
  return ret;
}


/* ////////////////////////////////////////////////////////////////////////////
////            lf_resource_function                                       ////
////            ե󥯥ɤ߹                             ////
//////////////////////////////////////////////////////////////////////////// */
void lf_resource_function(ptrbuf, msg, cmd)
    char    *ptrbuf;
    char    *msg[];
    char    *cmd[];
{
  int     i;
  char    *ptr, wbuf[5];

  for ( i = 0 ; i < 12 ; i++) {
    sprintf(wbuf, "F%d ", i + 1);
    if ( (ptr = strstr(ptrbuf, wbuf)) == ptrbuf ) {
      if ( (ptr = strchr(ptr, '\'')))
	strncpy(msg[i], ptr+1, 4);
      if ( (ptr = strchr(ptr+4, ','))) {
	if ( strlen(ptr+1)) {
	  if ( !(cmd[i] = calloc(1, strlen(ptr+1) + 1))) {
	    fprintf(stderr, "<<<  Out of Memory (function)  >>>\n");
	    exit (4);
	  }
	  strcpy(cmd[i], ptr+1);
	}
      }
      return;
    }
  }
}

/* ////////////////////////////////////////////////////////////////////////////
////            lf_resource                                                ////
////            ꥽ե뤫ɤ߹                             ////
//////////////////////////////////////////////////////////////////////////// */
void lf_resource()
{
  FILE    *fp;
  char    linebuf[256], homedir[80];
  char    app[] = "/usr/lib/X11/app-defaults/Lf";
  char    *ptr, *ptr1;
  int     i, mcnt, open_flag = 0;
  char    label[20];
  char    *header[] = {"tgz ", "lzh ", "zip "};

  /* -------------------------  Mcommand Default Set ------------------*/
  i = 0;
  while ( Mcmd_default[i] ) {
    Mcmd[i] = Mcmd_default[i];
    i++;
  }

  /* -------------------------  Function Command Initialize  ---------*/
  for ( i = 0 ; i < 13 ; i++) {
    fkcmd[i] = NULL;
    skcmd[i] = NULL;
    ckcmd[i] = NULL;
    akcmd[i] = NULL;
  }
  i = 0;
  while ( fkcmd_default[i] ) {
    fkcmd[i] = fkcmd_default[i];
    i++;
  }

  /*  resource file open  */
  if ( ptr = getenv("lfpath")) 
    if ( (fp = fopen(ptr, "r")))
      open_flag = 1;

  if ( !open_flag )
    if ( ptr = getenv("HOME")) {
      strcat(strcpy(homedir, ptr), "/.lfrc");
      if ( (fp = fopen(homedir, "r")))
	open_flag = 1;
    }
  
  if ( !open_flag )
    if ( !(fp = fopen(app, "r"))) {
      fprintf(stderr, "resoure file not found.\n");
      return;
    }
    
  /*  resource file read  */
  mcnt = 0;
  while ( fgets(linebuf, sizeof(linebuf), fp)) {
    if ( linebuf[0] == '#' ) {
      continue;
    } else if ((ptr = flagset(linebuf, "-jp "))) {
      if ( strstr(ptr, "yes") == ptr )
	jflag = 1;
    } else if ((ptr = flagset(linebuf, "-jpfn "))) {
      strcpy(jsFontName, ptr);
    } else if ((ptr = flagset(linebuf, "-locale "))) {
      strcpy(locale, ptr);
    } else if ((ptr = flagset(linebuf, "-fn "))) {
      strcpy(sFontName, ptr);
    } else if ((ptr = flagset(linebuf, "-bg "))) {
      strcpy(bgcolor, ptr);
    } else if ((ptr = flagset(linebuf, "-fg "))) {
      strcpy(fgcolor, ptr);
    } else if ((ptr = flagset(linebuf, "-cg "))) {
      strcpy(cgcolor, ptr);
    } else if ((ptr = flagset(linebuf, "-tg "))) {
      strcpy(tgcolor, ptr);
    } else if ((ptr = flagset(linebuf, "-eg "))) {
      strcpy(egcolor, ptr);
    } else if ((ptr = flagset(linebuf, "-dg "))) {
      strcpy(dgcolor, ptr);
    } else if ((ptr = flagset(linebuf, "-hg "))) {
      strcpy(hgcolor, ptr);
    } else if ((ptr = flagset(linebuf, "-mg1 "))) {
      strcpy(mgcolor1, ptr);
    } else if ((ptr = flagset(linebuf, "-mg2 "))) {
      strcpy(mgcolor2, ptr);
    } else if ((ptr = flagset(linebuf, "-mg3 "))) {
      strcpy(mgcolor3, ptr);
    } else if ((ptr = flagset(linebuf, "-mg4 "))) {
      strcpy(mgcolor4, ptr);
    } else if ((ptr = flagset(linebuf, "-window1 "))) {
      strcpy(windowenv1, ptr);
    } else if ((ptr = flagset(linebuf, "-window2 "))) {
      strcpy(windowenv2, ptr);
    } else if ((ptr = flagset(linebuf, "-cell "))) {
      if ( strstr(ptr, "yes") == ptr )
	color_flag = 1;
      else
	color_flag = 0;
    } else if ((ptr = flagset(linebuf, "-action "))) {
      if ( strstr(ptr, "enter") == ptr )
	action_flag = 0;   /* Enter key */
      else
	action_flag = 1;   /* Action key */
    }

    /* ----  Mcommand  ---- */
    else if ((ptr = flagset(linebuf, "-Mcommand "))) {
      if ( !(ptr1 = calloc(1, strlen(ptr) + 1))) {
	fprintf(stderr, "<<<  Out of Memory  (Mcommand)  >>>\n");
	exit (4);
      }
      strcpy(ptr1, ptr);
      Mcmd[mcnt++] = ptr1;
      Mcmd[mcnt] = NULL;
    }     
    /* ----  Function  ---- */
    else if ((ptr = flagset(linebuf, "-FKEY "))) {
      lf_resource_function(ptr, fkmsg, fkcmd);
    } else if ((ptr = flagset(linebuf, "-SHIFT "))) {
      lf_resource_function(ptr, skmsg, skcmd);
    } else if ((ptr = flagset(linebuf, "-CTRL "))) {
      lf_resource_function(ptr, ckmsg, ckcmd);
    } else if ((ptr = flagset(linebuf, "-ALT "))) {
      lf_resource_function(ptr, akmsg, akcmd);
    } else {
      if ( tgz_flag ) {
	i = tgz_flag - 1;
	if ( ptr = flagset(linebuf, strcat(strcpy(label, "-FKEY_"), header[i])))
	  lf_resource_function(ptr, fkmsg, fkcmd);
	else if ( ptr = flagset(linebuf, strcat(strcpy(label, "-SHIFT_"), header[i])))
	  lf_resource_function(ptr, skmsg, skcmd);
	else if ( ptr = flagset(linebuf, strcat(strcpy(label, "-CTRL_"), header[i])))
	  lf_resource_function(ptr, ckmsg, ckcmd);
	else if ( ptr = flagset(linebuf, strcat(strcpy(label, "-ALT_"), header[i])))
	  lf_resource_function(ptr, akmsg, akcmd);
      }
    }
  }
}
